'gbTemplate v2.0, Gary Beene

'Sometimes, when you create new app, you know it will contain a common set of features,
'plus or minus a few features that makes the program unique. To keep from re-inventing the
'wheel, you'd like a template that has all of those common features debugged and ready to go.

'That's what this snippet is - a template of 110+ of the standard features I use in most
'in my apps.  Most of the code is DDT, but some features could not be completed without
'the use of API.

'All of the features contained in this DDT skeleton are drawn from the snippets distributed
'with my gbSnippets freeware code librarian, available at  http://www.garybeene.com/sw/gbsnippets.htm.

'Compilable Example:
#Compile Exe
#Dim All
#Debug Error On     'catch array/pointer errors - OFF in production
#Debug Display On   'display untrapped errors   - OFF in production
#Include "Win32api.inc"
#Include "CommCtrl.inc"
#Resource "gbtemplate.pbr"

'MRU Equates =============================================================
'                       251-260 reserved for MRU menus (created during execution)
'                       these ID #'s are used in code

'SplitterBar Equates =============================================================
%IDC_Left             = 301   :   %IDC_LabelH           = 304
%IDC_Right            = 302   :   %IDC_LabelV           = 305
%IDC_Bottom           = 303

'Control Equates ======================================================
%IDC_StatusBar        = 401   :   %IDC_ListView         = 403
%IDC_Toolbar          = 402   :   %IDC_Graphic          = 404

'Toolbar Equates ======================================================
%IDT_New              = 501   :   %IDT_Undo             = 509
%IDT_Open             = 502   :   %IDT_Redo             = 510
%IDT_Save             = 503   :   %IDT_Find             = 511
%IDT_Print            = 504   :   %IDT_Shell            = 512
%IDT_Cut              = 505   :   %IDT_ShellDOS         = 513
%IDT_Copy             = 506   :   %IDT_ShellOpen        = 514
%IDT_Paste            = 507   :   %IDT_ShellExplore     = 515
%IDT_Delete           = 508   :   %IDT_Help             = 516

'Menu Equate ======================================================
%IDM_New              = 611   :   %IDM_Sep              = 616
%IDM_Open             = 612   :   %IDM_Exit             = 617
%IDM_Save             = 613   :   %IDM_HotKey           = 618
%IDM_Print            = 614   :
%IDM_PrintPreview     = 615

%IDM_Cut              = 621   :   %IDM_Paste            = 623
%IDM_Copy             = 622   :   %IDM_Delete           = 624

%IDM_1                = 631   :   %IDM_5                = 635
%IDM_2                = 632   :   %IDM_6                = 636
%IDM_3                = 633   :   %IDM_Fixed            = 637
%IDM_4                = 634

%IDM_SelectBackground = 641   :   %IDM_ShellDOS         = 646
%IDM_ResetSplitter    = 642   :   %IDM_ShellOpen        = 647
%IDM_SetPassword      = 643   :   %IDM_ShellExplore     = 648
%IDM_ClearPassword    = 644   :   %IDM_ShellTo          = 649
%IDM_ClearOpenMRU     = 645

%IDM_ConfirmDelete    = 651   :   %IDM_LimitSize        = 655
%IDM_OnTop            = 652   :   %IDM_EnableVoice      = 656
%IDM_SingleInstance   = 653   :   %IDM_ToolbarText      = 657
%IDM_UserTimer        = 654   :   %IDM_DisplayFileName  = 658

%IDM_Calculator       = 661   :   %IDM_DialogCapture    = 664
%IDM_CharacterMap     = 662   :   %IDM_ScreenCapture    = 665
%IDM_AsciiTable       = 663

%IDM_HelpFile         = 671   :   %IDM_WebSite          = 673
%IDM_EmailAuthor      = 672   :   %IDM_About            = 674

'Popup Menu Equates =================================================
%IDP_Cut              = 710   :   %IDP_Delete           = 713
%IDP_Copy             = 711   :   %IDP_CopyAll          = 714
%IDP_Paste            = 712

'About Dialog Equates ==============================================
%IDC_LabelVersion      = 801  :   %IDC_LabelWebSite    = 803
%IDC_LabelCopyRight    = 802  :   %IDC_LabelURL        = 804
                                  %IDC_AboutImage      = 805

'Print Preview Equates =====================================
%IDC_PrintAll             = 851  :  %IDC_PrintHeader      = 862
%IDC_PrintClose           = 852  :  %IDC_PrintFooter      = 863
%IDC_PrintGraphicHidden   = 853  :  %IDC_PrintBackGround  = 864
%IDC_PrintGraphicVisible  = 854  :  %IDC_PrintPage        = 865
%IDC_PrintToolTip         = 855  :  %IDC_PrintPages       = 866
%IDC_PrintLineLabel       = 856  :  %IDC_PrintPageSetup   = 867
%IDC_PrintLeft            = 857  :  %IDC_PrintMinPage     = 868
%IDC_PrintRight           = 858  :  %IDC_PrintMaxPage     = 869
%IDC_PrintShowMargins     = 859  :  %IDC_PrintRange       = 870
%IDC_PrintProperties      = 860  :  %IDC_PrinterSelect    = 871
%IDC_PrintOrientation     = 861  :  %IDC_PrintZoom        = 872
%IDC_PrintRangeLabel      = 874  :  %IDC_PrintPageLabel       = 875

'Other Equates =====================================================
%ID_UsageTimer        = 901
%ID_ImageTimer        = 902

'Custom UDT ====================================================================
Type CustomColors
   c(15) As Long
End Type


' Global Handles =====================================================================
Global hDlg, hRightTextBox, hAbout, hImageDialog, hThread As Dword
Global hDropDown, hListView, hDC_Graphic, hToolbar, hPrintDialog As Dword
Global hMenu, hContext, hMenuOptions, hMenuFile, hMenuView As Dword

'Global Splitter Variables ===========================================================
Global SplitVInWork, SplitHInWork, HBarLeft, VBarTop, Layout, FixedSPlitterBar As Long
Global XSplit, YSPlit As Single

'Global INI Variables =================================================================
Global CurrentFileName, OpenMRU() As String
Global BackColor As Long

'PrintPreview Global Variables =================================================================
Global PPFontName, PPPrintArray() As String
Global PPDeadZoneLeft, PPDeadZoneTop, PPDeadZoneRight, PPDeadZoneBottom As Single
Global PPMarginLeft, PPMarginRight, PPMarginTop, PPMarginBottom As Single
Global PPHeader, PPFooter, PPMaxWidth, PPPaperX, PPPaperY As Single
Global PPMaxPages, PPCurrentPage, PPLinesPerPage, PPScrollBarsVisible As Long
Global PPScreenPPIx,  PPScreenPPIy, PPPrinterPPIx, PPPrinterPPIy As Long
Global PPShowFooter, PPShowHeader, PPFontPoints, PPFontStyle As Long
Global PPOrientation, PPShowMargins, PPZoom As Long
Global PPSmallImageX, PPSmallImageY, PPScrollSizeX, PPScrollSizeY As Long
Global hPPFont, hPPDialog, hPPPageSetupDlg, hPPToolTip, hPPViewPort As Dword
Global PPhs,PPvs,PPwMax,PPhMax As Long

'Global Working Variables  =========================================================
Global oldProc As Dword
Global FileChanged, TimerCounter, TimerInterval, ColorMarker As Long
Global ImageName, VoiceMessage, CurrentFilePassword As String

' Main Function =======================================================================
Function PBMain()

   If InstanceTest = 0 Then If MsgBox ("Previous instance detected! Open new instance?", %MB_OkCancel + _
                   %MB_IconInformation, "Previous Instance Check") = %IdCancel Then Exit Function
    Dialog New Pixels, 0, "DDT Template",300,300,500,350, %WS_OverlappedWindow Or %WS_ClipChildren To hDlg
    CreateMenus
    BuildAcceleratorTable
    CreateControls
    CreateContextMenu
    CreateToolbarDropDownMenu
    Dialog Show Modal hDlg Call DlgProc()
End Function

CallBack Function DlgProc() As Long
   Local x,y,w,h,iReturn As Long
   Local tempz As Asciiz * %Max_Path
   Local temp As String
   Local hNode As Dword
   Select Case Cb.Msg
      'I always put WM_InitDialog first
      'Then I put all of the small sections next - easier to scroll through them
      'Finally, I always put WM_Command last because it is the very largest section of code
      Case %WM_InitDialog

         '  gbSnippets:  gbs_00046
         ReDim OpenMRU(9) As String     '9 is arbitrary # of file to keep in File Menu
         '  gbSnippets:  gbs_00056
         Settings_INI "get"
            If IsFalse(IsFile("default.txt")) Then CurrentFileName = "default.txt" : CreateDefaultFile
            CreateToolbar                'placed here because it needs the INI values
            PutOpenMRUListInFileMenu     'ID 251-260 reserved for MRU items
            OpenNewFileName CurrentFileName, 1  'needs CurrentFileName from INI, 1 means in startup
            SetDialogCaption             'needs Option info from INI

         Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Save, %TBState_Disabled
         Dialog Set Icon hDlg, "aaa"
         '  gbSnippets:  gbs_00041
         DragAcceptFiles hDlg, %True
         '  gbSnippets:  gbs_00260
         TimerInterval = 1000            'any value will do, preferably larger than smaller
         SetUserTimer
         '  gbSnippets:  gbs_000107
         OldProc = SetWindowLong(hRightTextBox, %GWL_WndProc, CodePtr(RightTextBoxProc))  'subclass
         '  gbSnippets:  gbs_00053
         iReturn = RegisterHotKey (Cb.Hndl, %IDM_HotKey, %HotKeyF_Control, %vk_h)   'Ctrl-H
         If iReturn = 0 Then MsgBox "Cannot register Ctrl-H hot key!", %MB_Ok, "gbTemplate"
         '  gbSnippets:  gbs_00044
         SetOnTop

         Treeview Get Root hDlg, %IDC_Left To hNode
         DisplayChildren hNode
         Treeview Set Expanded hDlg, %IDC_Left, hNode, %True

      Case %WM_HotKey
         '  gbSnippets:  gbs_00053
         Select Case Cb.WParam
            Case %IDM_HotKey
               MsgBox "Ctrl-H Pressed", %MB_Ok, "gbTemplate"
         End Select

      Case %WM_Destroy
         '  gbSnippets:  gbs_00260 (timer)  gbs_00138 (subclassing)
         KillTimer hDlg, %ID_UsageTimer
         Settings_INI "save"
         SetWindowLong hRightTextBox, %GWL_WNDPROC, OldProc   'un-subclass
         Dialog End hImageDialog       'just in case it's still showing

      Case %WM_Help
         '  gbSnippets:  gbs_00038
         tempz = "gbtemplate.chm"  'bring up Help file contents
         iReturn = ShellExecute(hDlg, "Open", tempz, $Nul, $Nul, %SW_ShowNormal)

      Case %WM_GETMINMAXINFO
         '  gbSnippets:  gbs_00045
         Menu Get State hMenuOptions, ByCmd %IDM_LimitSize To iReturn   'get the state
         If iReturn Then
            Local MM As MinMaxInfo Ptr
            MM=Cb.LParam
            @MM.ptMinTrackSize.x=150  '<-- Min X size of your window
            @MM.ptMinTrackSize.y=150  '<-- Min Y size of your window
            @MM.ptMaxTrackSize.x=800  '<-- Max X size of your window
            @MM.ptMaxTrackSize.y=600  '<-- Max Y size of your window
         End If

      Case %WM_Timer
         '  gbSnippets:  gbs_00260
         TimerCounter = TimerCounter + TimerInterval
         Statusbar Set Text hdlg, %IDC_StatusBar, 3, 0, Format$(TimerCounter/60000, "  0") _
                                       + ":" + Format$((TimerCounter Mod 60000) / 1000,"00")

      Case %WM_DROPFILES
         '  gbSnippets:  gbs_00041
         tempz = GetDroppedFileName(Cb.WParam)
         DragFinish Cb.WParam
         temp = tempZ
         OpenNewFileName temp, 0

      Case %WM_Size
         ResizeWindow

      Case %WM_SetCursor
            '  gbSnippets:  gbs_00060  gbs_00392
'            iReturn = GetDlgCtrlID (CB.wParam)
             Window Get Id Cb.WParam To iReturn
            'identify over which label control the mouse action took place
            If iReturn = %IDC_LabelH Then MousePtr 9 : Function = 1    '9 = horizontal cursor
            If iReturn = %IDC_LabelV Then MousePtr 7 : Function = 1    '7 = vertical cursor

            'monitors the 3 basic splitter bar mouse actions, lbuttondown, mousemose, lbuttonup
            Select Case Hi(Word, Cb.LParam)
               Case %WM_LButtonDown
                  'sets flags to say splitter action has started (no actual movement yet)
                  If iReturn = %IDC_LabelV Then SplitVInWork = 1
                  If iReturn = %IDC_LabelH Then SplitHInWork = 1
               Case %WM_MouseMove
                  'Repositions splitter bars to match mouse position (if position has changed)
                  If SplitVInWork Then If MoveBarUpDown Then ResizeWindow
                  If SplitHInWork Then If MoveBarLeftRight Then ResizeWindow
               Case %WM_LButtonUp
                  'sets flags to say splitter action has ended
                  SplitHInWork = 0 : SplitVInWork = 0
            End Select

        Case %WM_SYSCOMMAND
                '  gbSnippets:  gbs_00037
                If (Cb.WParam And &HFFF0) = %SC_Close Then          'trap Alt-F4 and X Button
                   Local Style As Long
                   If FileChanged Then
                      Style = %MB_YesNoCancel Or %MB_IconQuestion Or %MB_TaskModal
                      Select Case MsgBox("The file has been changed. Save the changes?", Style, "Applicaton Closing")
                         Case %IdYes
                            SaveCurrentFile
                            Function = 0    'Save, then destroy
                         Case %IdNo
                            Function = 0    'Not Save, then go ahead and close the app (call WM_Destroy)
                            SpeakToMe "Goodbye!", 750
                         Case %IdCancel
                            Function = 1   'True - abort the close - no further processing needed
                      End Select
                   Else
                      SpeakToMe "Goodbye!", 750
                   End If
                End If

      Case %WM_Notify
         Select Case Cb.NmId
            '  gbSnippets:  gbs_00291
            Case %IDC_Toolbar
               If Cb.NmCode = %TTN_GetDispInfo Then
                  Local P As TOOLTIPTEXT Ptr
                     P = Cb.LParam
                     Select Case Cb.NmId          'or this:   @P.hdr.idFrom
                        Case %IDT_New   : @P.@lpszText = "New"
                        Case %IDT_Open  : @P.@lpszText = "Open"
                        Case %IDT_Save  : @P.@lpszText = "Save"
                        Case %IDT_Print : @P.@lpszText = "Print (Default Printer)"
                        Case %IDT_Cut   : @P.@lpszText = "Cut"
                        Case %IDT_Copy  : @P.@lpszText = "Copy"
                        Case %IDT_Paste : @P.@lpszText = "Paste"
                        Case %IDT_Delete: @P.@lpszText = "Delete"
                        Case %IDT_Undo  : @P.@lpszText = "Undo"
                        Case %IDT_Redo  : @P.@lpszText = "Redo"
                        Case %IDT_Find  : @P.@lpszText = "Find"
                        Case %IDT_Help  : @P.@lpszText = "Help"
                     End Select
               End If

               '  gbSnippets:  gbs_00112
               Local nmtb As TBNOTIFY Ptr, rc As RECT
               nmtb = Cb.LParam
               Select Case @nmtb.hdr.Code
                   Case %TBN_DROPDOWN
                       Select Case @nmtb.iItem
                           Case %IDT_Shell
                               Control Send hDlg, %IDC_Toolbar, %TB_GETRECT, %IDT_Shell, VarPtr(rc)
                               MapWindowPoints(hToolbar, %HWND_Desktop, ByVal VarPtr(rc), 2)
                               TrackPopupMenu (hDropDown, 0, rc.nLeft, rc.nBottom, 0, hDlg, ByVal %NULL)
                       End Select
               End Select


            Case %IDC_Left
               Select Case Cb.NmCode
                  '  gbSnippets:  gbs_00525  gbs_00526
                  Case %TVN_ItemExpanding
                     Local N As NM_TreeView Ptr
                     N = Cb.LParam
                     DisplayChildren @N.ItemNew.hItem
                  Case %TVN_SelChanged
                     DisplayFiles
               End Select

            Case %IDC_Bottom
               Select Case Cb.NmCode
                  Static SortDirection As Long
                  '  gbSnippets:  gbs_00097
                  Case %LVN_ColumnClick
                     Local pNMLV  As NM_LISTVIEW' PTR
                     Type Set pNMLV = Cb.NmHdr$(SizeOf(pNMLV))  ' Obtain the NM_LISTVIEW UDT
                     Select Case pNMLV.iSubiTem
                         Case 0
                           If SortDirection Then
                              ListView Sort hDlg, %IDC_Bottom, 1, Descend
                           Else
                              ListView Sort hDlg, %IDC_Bottom, 1, Ascend
                           End If
                           SortDirection = SortDirection Xor 1
                         Case 1 :  MsgBox "Sort by size is not implemented.", %MB_Ok, "gbTemplate"
                         Case 2 :  MsgBox "Sort by date is not implemented.", %MB_Ok, "gbTemplate"
                     End Select
                  Case %NM_Click    '%LVN_ItemChanged
                     ListView Get Select hDlg, %IDC_Bottom To iReturn          'get row
                     ListView Get Text hDlg, %IDC_Bottom, iReturn, 1 To temp  'get hNode
                     Treeview Get Select hDlg, %IDC_Left To hNode           'selected node in TreeView
                     OpenNewFileName Trim$(FullTreePath(hNode),"\") + "\" + temp, 0
               End Select

      End Select

      Case %WM_Command
         Select Case Cb.Ctl

            'Menu - File
            Case %IDM_New   : OpenNewFileName "<untitled>", 0
            Case %IDM_Open  : SelectFileToOpen
            Case %IDM_Save  : SaveFileAs
            Case %IDM_Print : SelectPrinter           'use toolbar to print immediately
            Case %IDM_PrintPreview : DisplayPrintPreviewDialog    'use toolbar to print immediately
            Case %IDM_Exit  : Dialog End hDlg         'initiates %WM_Destroy

            'Menu - MRU
            '  gbSnippets:  gbs_00046
            Case 251 To 260        'the 10 Open MRU entries under the File menu
               If Cb.CtlMsg = %BN_Clicked Then         '%ID values 251-260 used for MRU list
                  Menu Get Text hMenuFile, ByCmd Cb.Ctl To temp
                  OpenNewFileName temp, 0
               End If

             'Menu - Edit
             Case %IDM_Cut    : CutText
             Case %IDM_Copy   : CopyText
             Case %IDM_Paste  : PasteText
             Case %IDM_Delete : DeleteText

            'Menu - Layout
            Case %IDM_1
                ClearLayoutMenus : Layout = 1
                Menu Set State hMenuView, ByCmd %IDM_1, 8  'set the state
                ResizeWindow
            Case %IDM_2
                ClearLayoutMenus : Layout = 2
                Menu Set State hMenuView, ByCmd %IDM_2, 8  'set the state
                ResizeWindow
            Case %IDM_3
                ClearLayoutMenus : Layout = 3
                Menu Set State hMenuView, ByCmd %IDM_3, 8  'set the state
                ResizeWindow
            Case %IDM_4
                ClearLayoutMenus : Layout = 4
                Menu Set State hMenuView, ByCmd %IDM_4, 8  'set the state
                ResizeWindow
            Case %IDM_5
                ClearLayoutMenus : Layout = 5
                Menu Set State hMenuView, ByCmd %IDM_5, 8  'set the state
                ResizeWindow
            Case %IDM_6
                ClearLayoutMenus : Layout = 6
                Menu Set State hMenuView, ByCmd %IDM_6, 8  'set the state
                ResizeWindow
            '  gbSnippets:  gbs_00060  gbs_00392
            Case %IDM_Fixed
               FixedSplitterBar = FixedSplitterBar  Xor 1     'flip between 0 and 1
               Menu Set State hMenuView, ByCmd %IDM_Fixed, FixedSplitterBar * 8
               Dialog Get Client hDlg To w,h
               'adjusts VBarTop/HBarLeft or xSplit/ySplit when option is changed
               'both are not kept current at all times - only the pair in use
               If FixedSplitterBar Then
                  VBarTop = h - ySplit * h
                  HBarLeft = xSplit * w
               Else
                  ySplit = (h-VBarTop) / h
                  xSplit = HBarLeft / w
               End If
               ResizeWindow

            'Menu - Actions
            Case %IDM_SelectBackground  :  SetBackgroundColor
            Case %IDM_ResetSplitter     : ResetSplitter
            Case %IDM_SetPassword       :  CurrentFilePassword = AskUserForPassword
            Case %IDM_ClearPassword     :  CurrentFilePassword = ""
            Case %IDM_ClearOpenMRU      :  ClearOpenMRUList
            '  gbSnippets:  gbs_00156
            Case %IDM_ShellDOS
                iReturn = Shell( "cmd /K chdir /D " & PathName$(Path,CurrentFileName))       'WinNT, 2000, XP, Vista
            '  gbSnippets:  gbs_00158
             Case %IDM_ShellOpen
                tempz = PathName$(Path,CurrentFileName$)
                ShellExecute(hDlg, "Open", tempz, $Nul, $Nul, %SW_Restore)
            '  gbSnippets:  gbs_00157
             Case %IDM_ShellExplore
                tempz = PathName$(Path,CurrentFileName$)
                ShellExecute(hDlg, "Explore", tempz, $Nul, $Nul, %SW_Restore)

            'Menu - Options
            '  gbSnippets:  gbs_00200 (flip menu check state)
            Case %IDM_ConfirmDelete
               Menu Get State hMenuOptions, ByCmd %IDM_ConfirmDelete To iReturn   'get the state
               Menu Set State hMenuOptions, ByCmd %IDM_ConfirmDelete, Abs(IsFalse iReturn)*8  'flip the state
            Case %IDM_OnTop
               Menu Get State hMenuOptions, ByCmd %IDM_OnTop To iReturn   'get the state
               Menu Set State hMenuOptions, ByCmd %IDM_OnTop, Abs(IsFalse iReturn)*8  'flip the state
               SetOnTop
            Case %IDM_SingleInstance
               Menu Get State hMenuOptions, ByCmd %IDM_SingleInstance To iReturn   'get the state
               Menu Set State hMenuOptions, ByCmd %IDM_SingleInstance, Abs(IsFalse iReturn)*8  'flip the state
            Case %IDM_UserTimer
               Menu Get State hMenuOptions, ByCmd %IDM_UserTimer To iReturn   'get the state
               Menu Set State hMenuOptions, ByCmd %IDM_UserTimer, Abs(IsFalse iReturn)*8  'flip the state
               SetUserTimer
            Case %IDM_LimitSize
               Menu Get State hMenuOptions, ByCmd %IDM_LimitSize To iReturn   'get the state
               Menu Set State hMenuOptions, ByCmd %IDM_LimitSize, Abs(IsFalse iReturn)*8  'flip the state
            Case %IDM_EnableVoice
               Menu Get State hMenuOptions, ByCmd %IDM_EnableVoice To iReturn   'get the state
               Menu Set State hMenuOptions, ByCmd %IDM_EnableVoice, Abs(IsFalse iReturn)*8  'flip the state
            Case %IDM_ToolbarText
               Menu Get State hMenuOptions, ByCmd %IDM_ToolbarText To iReturn   'get the state
               Menu Set State hMenuOptions, ByCmd %IDM_ToolbarText, Abs(IsFalse iReturn)*8  'flip the state
               Control Kill hDlg, %IDC_Toolbar
               CreateToolbar
               ResizeWindow
            Case %IDM_DisplayFileName
               Menu Get State hMenuOptions, ByCmd %IDM_DisplayFileName To iReturn   'get the state
               Dialog Set Text hDlg, "gbTemplate" + Choose$(iReturn+1, "", Space$(8) + CurrentFileName)
               Menu Set State hMenuOptions, ByCmd %IDM_DisplayFileName, Abs(IsFalse iReturn)*8  'flip the state

            'Menu - Tools
            Case %IDM_Calculator       : Shell("calc.Exe")
            Case %IDM_CharacterMap     : Shell("charmap.Exe")
            '  gbSnippets:  gbs_00009
            Case %IDM_AsciiTable       : ShowAsciiTable

            '  gbSnippets:  gbs_00165
            Case %IDM_DialogCapture    : Sleep 250 : keybd_event(%VK_SnapShot, 1, 0, 0)  'place active dialog on clipboard
            '  gbSnippets:  gbs_00166
            Case %IDM_ScreenCapture    : Sleep 250 : keybd_event(%VK_SnapShot, 0, 0, 0) 'screen on clipboard

            'Menu - Help
            '  gbSnippets:  gbs_00052
            Case %IDM_HelpFile
               tempz = EXE.Path$ + "gbtemplate.chm"
               iReturn = ShellExecute(hDlg, "Open", tempz, $Nul, $Nul, %SW_ShowNormal)

            '  gbSnippets:  gbs_00185
            Case %IDM_EmailAuthor
               tempz = "mailto:gbeene@airmail.net?subject=gbSnippets&body=Comments:"
               iReturn = ShellExecute(hDlg, "Open", tempz , $Nul, $Nul, %SW_ShowNormal)

            '  gbSnippets:  gbs_00184
            Case %IDM_WebSite
               tempz = "http://www.garybeene.com/"
               iReturn = ShellExecute(hDlg, "Open", tempz, $Nul, $Nul, %SW_ShowNormal)

            Case %IDM_About           : DisplayAboutDialog

            'Menu - Popup (Right)
            Case %IDP_Cut      : CutText
            Case %IDP_Copy     : CopyText
            Case %IDP_Paste    : PasteText
            Case %IDP_Delete   : DeleteText
            Case %IDP_CopyAll  : CopyAllText

            'Menu - Popup (Toolbar dropdown button)
            '  gbSnippets:  gbs_00157
             Case %IDT_Shell
                tempz = PathName$(Path,CurrentFileName$)
                ShellExecute(hDlg, "Explore", tempz, $Nul, $Nul, %SW_Restore)
            '  gbSnippets:  gbs_00156
            Case %IDT_ShellDOS
                iReturn = Shell( "cmd /K chdir /D " & PathName$(Path,CurrentFileName))       'WinNT, 2000, XP, Vista
            '  gbSnippets:  gbs_00158
             Case %IDT_ShellOpen
                tempz = PathName$(Path,CurrentFileName$)
                ShellExecute(hDlg, "Open", tempz, $Nul, $Nul, %SW_Restore)
            '  gbSnippets:  gbs_00157
             Case %IDT_ShellExplore
                tempz = PathName$(Path,CurrentFileName$)
                ShellExecute(hDlg, "Explore", tempz, $Nul, $Nul, %SW_Restore)

            'Toolbar Buttons
            Case %IDT_New   : OpenNewFileName "<untitled>", 0
            Case %IDT_Open  : SelectFileToOpen
            Case %IDT_Save  : SaveCurrentFile
            Case %IDT_Print : XPrint Attach Default : PrintCurrentFile
            Case %IDT_Cut   : CutText
            Case %IDT_Copy  : CopyText
            Case %IDT_Paste : PasteText
            Case %IDT_Delete: DeleteText
            Case %IDT_Undo  : MsgBox "Undo Not Implemented", %MB_Ok + %MB_IconInformation, "Toolbar Button Pressed"
            Case %IDT_Redo  : MsgBox "Redo Not Implemented", %MB_Ok + %MB_IconInformation, "Toolbar Button Pressed"
            Case %IDT_Find  : MsgBox "Find Not Implemented", %MB_Ok + %MB_IconInformation, "Toolbar Button Pressed"
            Case %IDT_Help
               '  gbSnippets:  gbs_00038
               tempz = "gbtemplate.chm"  'bring up Help file contents
               iReturn = ShellExecute(hDlg, "Open", tempz, $Nul, $Nul, %SW_ShowNormal)


            'Controls
            Case %IDC_Right
               Select Case Cb.CtlMsg
                  Case %EN_Change
                     Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Save, %TBState_Enabled
                     FileChanged = 1
               End Select
         End Select

   End Select
End Function

' INI File (Save Settings) ====================================================================
'  gbSnippets:  gbs_0046  gbs_0056
Sub Settings_INI(Task$)
   Local i, x, y, iResult As Long
   Local xResult, yResult, INIFileName, temp As Asciiz * %Max_Path

   'defines file name (any file name will work)
   INIFileName = EXE.Path$ + "gbtemplate.ini"

   'allows clearing of INI content by using application command tail:  'myapp.exe \clear'
   If InStr(Command$,"\clear") Then
      Kill INIFileName
   End If

   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "300", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "300", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult$), Val(yResult$)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "600", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "475", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult$), Val(yResult$)   'width/height


      'get value for string variable
      Getprivateprofilestring "All", "CFN", "<untitled>", temp, %Max_Path, INIFileName
      CurrentFileName = temp

      For i = 0 To 9
         Getprivateprofilestring "OpenMRU", "OpenMRU" + Format$(i,"00"), "", temp, %Max_Path, INIFileName
         OpenMRU(i) = temp
      Next i

      'get value for numeric variables
      Getprivateprofilestring "All", "XSplit", "0.3", temp, %Max_Path, INIFileName
      XSplit = Val(temp)

      Getprivateprofilestring "All", "YSplit", "0.6", temp, %Max_Path, INIFileName
      YSplit = Val(temp)

      Getprivateprofilestring "All", "Layout", "1", temp, %Max_Path, INIFileName
      Layout = Val(temp)

      Getprivateprofilestring "All", "HBarLeft", "200", temp, %Max_Path, INIFileName
      HBarLeft = Val(temp)

      Getprivateprofilestring "All", "VBarTop", "300", temp, %Max_Path, INIFileName
      VBarTop = Val(temp)

      Getprivateprofilestring "All", "FixedSplitterBar", "0", temp, %Max_Path, INIFileName
      FixedSplitterBar = Val(temp)

      Getprivateprofilestring "All", "BackColor", Str$(%White), temp, %Max_Path, INIFileName
      BackColor = Val(temp)

      'get menu state
      Getprivateprofilestring "All", "ConfirmDelete", "0", temp, %Max_Path, INIFileName
      iResult& = Val(temp) : Menu Set State hMenu, ByCmd %IDM_ConfirmDelete, iResult&

      Getprivateprofilestring "All", "OnTop", "0", temp, %Max_Path, INIFileName
      iResult& = Val(temp) : Menu Set State hMenu, ByCmd %IDM_OnTop, iResult&

      Getprivateprofilestring "All", "SingleInstance", "0", temp, %Max_Path, INIFileName
      iResult& = Val(temp) : Menu Set State hMenu, ByCmd %IDM_SingleInstance, iResult&

      Getprivateprofilestring "All", "UserTimer", "0", temp, %Max_Path, INIFileName
      iResult& = Val(temp) : Menu Set State hMenu, ByCmd %IDM_UserTimer, iResult&

      Getprivateprofilestring "All", "LimitSize", "0", temp, %Max_Path, INIFileName
      iResult& = Val(temp) : Menu Set State hMenu, ByCmd %IDM_LimitSize, iResult&

      Getprivateprofilestring "All", "EnableVoice", "0", temp, %Max_Path, INIFileName
      iResult& = Val(temp) : Menu Set State hMenu, ByCmd %IDM_EnableVoice, iResult&

      Getprivateprofilestring "All", "ToolbarText", "8", temp, %Max_Path, INIFileName
      iResult& = Val(temp) : Menu Set State hMenu, ByCmd %IDM_ToolbarText, iResult&

      Getprivateprofilestring "All", "DisplayFileName", "8", temp, %Max_Path, INIFileName
      iResult& = Val(temp) : Menu Set State hMenu, ByCmd %IDM_DisplayFileName, iResult&
   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If

      'save string variable
      temp = CurrentFileName
      WritePrivateProfileString "All", "CFN", temp, INIFileName

      For i = 0 To 9
         temp = OpenMRU(i)
         WritePrivateProfileString "OpenMRU", "OpenMRU" + Format$(i,"00"), temp, INIFileName
      Next i

      'save numeric variable
      temp = Str$(XSplit)
      WritePrivateProfileString "All", "XSplit", temp, INIFileName

      temp = Str$(YSplit)
      WritePrivateProfileString "All", "YSplit", temp, INIFileName

      temp = Str$(Layout)
      WritePrivateProfileString "All", "Layout", temp, INIFileName

      temp = Str$(HBarLeft)
      WritePrivateProfileString "All", "HBarLeft", temp, INIFileName

      temp = Str$(VBarTop)
      WritePrivateProfileString "All", "VBarTop", temp, INIFileName

      temp = Str$(FixedSplitterBar)
      WritePrivateProfileString "All", "FixedSplitterBar", temp, INIFileName

      temp = Str$(BackColor)
      WritePrivateProfileString "All", "BackColor", temp, INIFileName

      temp = Str$(Layout)
      WritePrivateProfileString "All", "Layout", temp, INIFileName

      'save menu state
      Menu Get State hMenu, ByCmd %IDM_ConfirmDelete To iResult&
      temp = Str$(iResult&) : WritePrivateProfileString "All", "ConfirmDelete", temp, INIFileName

      Menu Get State hMenu, ByCmd %IDM_OnTop To iResult&
      temp = Str$(iResult&) : WritePrivateProfileString "All", "OnTop", temp, INIFileName

      Menu Get State hMenu, ByCmd %IDM_SingleInstance To iResult&
      temp = Str$(iResult&) : WritePrivateProfileString "All", "SingleInstance", temp, INIFileName

      Menu Get State hMenu, ByCmd %IDM_UserTimer To iResult&
      temp = Str$(iResult&) : WritePrivateProfileString "All", "UserTimer", temp, INIFileName

      Menu Get State hMenu, ByCmd %IDM_LimitSize To iResult&
      temp = Str$(iResult&) : WritePrivateProfileString "All", "LimitSize", temp, INIFileName

      Menu Get State hMenu, ByCmd %IDM_EnableVoice To iResult&
      temp = Str$(iResult&) : WritePrivateProfileString "All", "EnableVoice", temp, INIFileName

      Menu Get State hMenu, ByCmd %IDM_ToolbarText To iResult&
      temp = Str$(iResult&) : WritePrivateProfileString "All", "ToolbarText", temp, INIFileName

      Menu Get State hMenu, ByCmd %IDM_DisplayFileName To iResult&
      temp = Str$(iResult&) : WritePrivateProfileString "All", "DisplayFileName", temp, INIFileName

   End If

'Apply settings as required
   Menu Set State hMenuView, ByCmd %IDM_1 + Layout - 1, 8  'set the state

   Control Set Color hDlg, %IDC_Left, %Black, BackColor
   Control Set Color hDlg, %IDC_Right, %Black, BackColor
   Control Set Color hDlg, %IDC_Bottom, %Black, BackColor

   Menu Get State hMenuOptions, ByCmd %IDM_DisplayFileName To iResult   'get the state
   If iResult Then
      Dialog Set Text hDlg, "gbTemplate     " + CurrentFileName
   Else
      Dialog Set Text hDlg, "gbTemplate"
   End If
End Sub

' SplitterBar ==============================================================================
' gbSnippets:  gbs_00060   gbs_00392
Function MoveBarUpDown As Long
    Local pt As Point, h As Long, w As Long
    Static oldY As Long
    Dialog Get Client hDlg To w,h
    GetCursorPos pt               'pt has xy screen coordinates
    ScreenToClient hDlg, pt       'pt now has client coordinates
'    If h-pt.y < 50 Then Exit Function   'limit right motion   'optional
'    If pt.y < 50 Then Exit Function                            'optional
    YSplit = (pt.y-3) / h         'actually, should only do one or the other
    VBarTop = h - (Pt.y-3)        'actually, should only do one or the other
    If pt.y <> oldY Then Function = %True : oldY = pt.y
End Function

Function MoveBarLeftRight As Long
    Local pt As Point, h As Long, w As Long
    Static oldX As Long
    Dialog Get Client hDlg To w,h
    GetCursorPos pt               'pt has xy screen coordinates
    ScreenToClient hDlg, pt       'pt now has client coordinates
'    If w-pt.x < 50 Then Exit Function   'limit right motion       'optional
'    If pt.x < 50 Then Exit Function                                 'optional
    XSplit = (pt.x-3) / w        'actually, should only do one or the other
    HBarLeft = pt.x-3            'actually, should only do one or the other
    If pt.x <> oldX Then Function = %True : oldX = pt.x
End Function

Sub ClearLayoutMenus
   Menu Set State hMenuView, ByCmd %IDM_1, 0 'uncheck
   Menu Set State hMenuView, ByCmd %IDM_2, 0 'uncheck
   Menu Set State hMenuView, ByCmd %IDM_3, 0 'uncheck
   Menu Set State hMenuView, ByCmd %IDM_4, 0 'uncheck
   Menu Set State hMenuView, ByCmd %IDM_5, 0 'uncheck
   Menu Set State hMenuView, ByCmd %IDM_6, 0 'uncheck
End Sub

Sub ResetSplitter
   Local w, h As Long
   Dialog Get Client hDlg To w, h
   ClearLayoutMenus
   Menu Set State hMenuView, ByCmd %IDM_1, 8  'set the state
   Menu Set State hMenuView, ByCmd %IDM_Fixed, 8  'set the state
   Layout = 1
   HBarLeft = h/2
   VBarTop = w/4
   FixedSplitterBar = 1
   XSplit = 0.5
   YSPlit = 0.3
   ResizeWindow
End Sub

' Resize Window ============================================================================
' gbSnippets:  gbs_0054  gbs_00060   gbs_00392
Sub ResizeWindow

   Local h As Long, w As Long, HLeft&, VTop&
   Local M As Long, T As Long
   Local yStatus As Long, yTool As Long
   Control Get Size hDlg, %IDC_StatusBar To w,yStatus
   Control Get Size hDlg, %IDC_Toolbar To w,yTool
   Dialog Get Client hDlg To w,h
   M = 5   'margin around controls
   T = 6    'splitter thickness (smallest dimension)
   If Layout = 0 Then Layout = 1

   'get the splitter bar positions - top of vertical splitter (VTop) and
   'left of horizontal splitter (HLeft).  These will be used in positioning
   'controls on the dialog.  Result depends on whether fixed or percentage
   'positioning is selected by the user.
   If FixedSplitterBar Then
      VTop = h - VBarTop
      HLeft = HBarLeft
   Else
      VTop = ySplit*h
      HLeft = xSplit*w
   End If

   Select Case Layout         'Function Layout returns a value 1-6
      Case 1    'left beside right, both above bottom
         'visibility
         Control Show State hDlg, %IDC_LabelH, %SW_Show
         Control Show State hDlg, %IDC_LabelV, %SW_Show
         Control Show State hDlg, %IDC_Bottom, %SW_Show

         'H splitter bar loc/size
         Control Set Loc hDlg, %IDC_LabelH, HLeft, yTool + M
         Control Set Size hDlg, %IDC_LabelH, T, VTop - yTool - M

         'V splitter bar loc/size
         Control Set Loc hDlg, %IDC_LabelV, M, VTop
         Control Set Size hDlg, %IDC_LabelV, w - 2*M, T

         'Left size/loc
         Control Set Loc  hDlg, %IDC_Left, M, yTool + M
         Control Set Size hDlg, %IDC_Left, HLeft - 2*M, VTop - yTool - 2*M

         'Right size/loc
         Control Set Loc  hDlg, %IDC_Right, HLeft + T + M, yTool + M
         Control Set Size hDlg, %IDC_Right, w - HLeft - 2*M - T, VTop - yTool - 2*M

         'Bottom size/loc
         Control Set Loc  hDlg, %IDC_Bottom, M, VTop + T + M
         Control Set Size hDlg, %IDC_Bottom, w - 2*M, h - VTop - yStatus - 2*M - T


      Case 2    'left over bottom, right top-to-bottom
         'visibility
         Control Show State hDlg, %IDC_LabelH, %SW_Show
         Control Show State hDlg, %IDC_LabelV, %SW_Show
         Control Show State hDlg, %IDC_Bottom, %SW_Show

         'H splitter bar loc/size
         Control Set Loc hDlg, %IDC_LabelH, HLeft, yTool + 5
         Control Set Size hDlg, %IDC_LabelH, T, h - yTool - yStatus - 2*M

         'V splitter bar loc/size
         Control Set Loc hDlg, %IDC_LabelV, M, VTop
         Control Set Size hDlg, %IDC_LabelV, HLeft - M, T

         'Left size/loc
         Control Set Loc  hDlg, %IDC_Left, M, yTool + M
         Control Set Size hDlg, %IDC_Left, HLeft - 2*M, VTop - yTool - 2*M

         'Right size/loc
         Control Set Loc  hDlg, %IDC_Right, HLeft + T + M, yTool + M
         Control Set Size hDlg, %IDC_Right, w - HLeft - 2*M - T, h - yTool - yStatus - 2*M

         'Bottom size/loc
         Control Set Loc  hDlg, %IDC_Bottom, M, VTop + T + M
         Control Set Size hDlg, %IDC_Bottom, HLeft - 2*M, h - VTop - yStatus - 2*M - T

      Case 3    'left beside right, bottom not visible
         'visibility
         Control Show State hDlg, %IDC_LabelH, %SW_Show
         Control Show State hDlg, %IDC_LabelV, %SW_Hide
         Control Show State hDlg, %IDC_Bottom, %SW_Hide

         'H splitter bar loc/size
         Control Set Loc hDlg, %IDC_LabelH, HLeft, yTool + M
         Control Set Size hDlg, %IDC_LabelH, T, h - yTool - yStatus - 2*M

         'V splitter bar loc/size
         '   none - not visible

         'Left loc/size
         Control Set Loc  hDlg, %IDC_Left, M, yTool + M
         Control Set Size hDlg, %IDC_Left, HLeft - 2*M, h - yTool - yStatus - 2*M

         'Right loc/size
         Control Set Loc  hDlg, %IDC_Right, HLeft + T + M, yTool + M
         Control Set Size hDlg, %IDC_Right, w - HLeft - 2*M - T, h - yTool - yStatus - 2*M

         'Bottom loc/size
         '   none - not visible

      Case 4    'left beside right, both below bottom
         'visibility
         Control Show State hDlg, %IDC_LabelH, %SW_Show
         Control Show State hDlg, %IDC_LabelV, %SW_Show
         Control Show State hDlg, %IDC_Bottom, %SW_Show

         'H splitter bar loc/size
         Control Set Loc hDlg, %IDC_LabelH, HLeft, VTop + T
         Control Set Size hDlg, %IDc_LabelH, T, h - VTop - yStatus - M - T

         'V splitter bar loc/size
         Control Set Loc hDlg, %IDC_LabelV, M, VTop
         Control Set Size hDlg, %IDC_LabelV, w - 2*M, T

         'Left loc/size
         Control Set Loc  hDlg, %IDC_Left, M, VTop + T + M
         Control Set Size hDlg, %IDC_Left, HLeft - 2*M, h - VTop - yStatus - 2*M - T

         'Right loc/size
         Control Set Loc  hDlg, %IDC_Right, HLeft + T + M, VTop + T + M
         Control Set Size hDlg, %IDC_Right, w - HLeft - 2*M - T, h - VTop - yStatus - 2*M - T

         'Bottom loc/size
         Control Set Loc  hDlg, %IDC_Bottom, M, yTool + M
         Control Set Size hDlg, %IDC_Bottom, w - 2*M, VTop - yTool - 2*M


      Case 5    'left top-to-bottom, right over bottom
         'visibility
         Control Show State hDlg, %IDC_LabelH, %SW_Show
         Control Show State hDlg, %IDC_LabelV, %SW_Show
         Control Show State hDlg, %IDC_Bottom, %SW_Show

         'H splitter bar loc/size
         Control Set Loc hDlg, %IDC_LabelH, HLeft, yTool + M
         Control Set Size hDlg, %IDC_LabelH, T, h - yTool - yStatus - 2*M

         'V splitter bar loc/size
         Control Set Loc hDlg, %IDC_LabelV, HLEFT + T, VTop
         Control Set Size hDlg, %IDC_LabelV, w - HLeft - T - M, T

         'Left loc/size
         Control Set Loc  hDlg, %IDC_Left, M, yTool + M
         Control Set Size hDlg, %IDC_Left, HLeft - 2*M, h - yTool - yStatus - 2*M

         'Right loc/size
         Control Set Loc  hDlg, %IDC_Right, HLeft + T + M, yTool + M
         Control Set Size hDlg, %IDC_Right, w - HLeft - T - 2*M, VTop - yTool - 2*M

         'Bottom loc/size
         Control Set Loc  hDlg, %IDC_Bottom, HLeft + T + M, VTop + T + M
         Control Set Size hDlg, %IDC_Bottom, w - HLeft - T - 2*M, h - VTop - yStatus - 2*M - T

      Case 6    'left over right, bottom not visible
         'visibility
         Control Show State hDlg, %IDC_LabelH, %SW_Hide
         Control Show State hDlg, %IDC_LabelV, %SW_Show
         Control Show State hDlg, %IDC_Bottom, %SW_Hide

         'H splitter bar loc/size
         '  none - not visible

         'V splitter bar loc/size
         Control Set Loc hDlg, %IDC_LabelV, M, VTop
         Control Set Size hDlg, %IDC_LabelV, w - 2*M, T

         'Left loc/size
         Control Set Loc  hDlg, %IDC_Left, M, yTool + M
         Control Set Size hDlg, %IDC_Left, w - 2*M, VTop - yTool - 2*M

         'Right loc/size
         Control Set Loc  hDlg, %IDC_Right, M, VTop + T + M
         Control Set Size hDlg, %IDC_Right, w - 2*M, h - VTop - yStatus - 2*M - T

         'Bottom loc/size
         '   none - not visible
   End Select
   Statusbar Set Parts hDlg, %IDC_StatusBar, w/3, w/3, w/3
   Dialog ReDraw hDlg
End Sub

' Menus =====================================================================================
' gbSnippets:  gbs_00295  gbs_00200  gbs_00201  gbs_00202  gbs_00434
Sub CreateMenus
    Local hMenuEdit, hMenuActions As Dword
    Local hMenuShell, hMenuTools, hMenuHelp As Dword

    'Create Main Menu
    Menu New Bar To hMenu
    Menu New PopUp To hMenuFile
    Menu New PopUp To hMenuEdit
    Menu New PopUp To hMenuView
    Menu New PopUp To hMenuActions
    Menu New PopUp To hMenuOptions
    Menu New PopUp To hMenuTools
    Menu New PopUp To hMenuHelp

    'File Menu
    Menu Add PopUp, hMenu, "&File", hMenuFile, %MF_Enabled
    Menu Add String, hMenuFile, "&New"   + $Tab + "Ctrl-N", %IDM_New, %MF_Enabled
    Menu Add String, hMenuFile, "&Open"  + $Tab + "Ctrl-O", %IDM_Open, %MF_Enabled
    Menu Add String, hMenuFile, "&Save"  + $Tab + "Ctrl-S", %IDM_Save, %MF_Enabled
    Menu Add String, hMenuFile, "&Print" + $Tab + "Ctrl-P", %IDM_Print, %MF_Enabled
    Menu Add String, hMenuFile, "P&rint Preview", %IDM_PrintPreview, %MF_Enabled
    Menu Add String, hMenuFile, "-", %IDM_Sep, 0
    Menu Add String, hMenuFile, "E&xit", %IDM_Exit, %MF_Enabled

    'Add resource bitmaps to File menu
    Local hBMP As Dword
    hBmp = LoadImage(GetModuleHandle(""), "newb", %IMAGE_BITMAP, 0, 0, %LR_MonoChrome)
    SetMenuItemBitmaps hMenuFile, 0, %MF_ByPosition, hBMP, hBMP
    hBmp = LoadImage(GetModuleHandle(""), "openb", %IMAGE_BITMAP, 0, 0, %LR_MonoChrome)
    SetMenuItemBitmaps hMenuFile, 1, %MF_ByPosition, hBMP, hBMP
    hBmp = LoadImage(GetModuleHandle(""), "saveb", %IMAGE_BITMAP, 0, 0, %LR_MonoChrome)
    SetMenuItemBitmaps hMenuFile, 2, %MF_ByPosition, hBMP, hBMP
    hBmp = LoadImage(GetModuleHandle(""), "printb", %IMAGE_BITMAP, 0, 0, %LR_MonoChrome)
    SetMenuItemBitmaps hMenuFile, 3, %MF_ByPosition, hBMP, hBMP
    hBmp = LoadImage(GetModuleHandle(""), "whiteb", %IMAGE_BITMAP, 0, 0, %LR_MonoChrome)
    SetMenuItemBitmaps hMenuFile, 5, %MF_ByPosition, hBMP, hBMP

    'Edit Menu
    Menu Add PopUp, hMenu, "&Edit", hMenuEdit, %MF_Enabled
    Menu Add String, hMenuEdit, "&Cut", %IDM_Cut, %MF_Enabled
    Menu Add String, hMenuEdit, "C&opy", %IDM_Copy, %MF_Enabled
    Menu Add String, hMenuEdit, "&Paste", %IDM_Paste, %MF_Enabled
    Menu Add String, hMenuEdit, "&Delete", %IDM_Delete, %MF_Enabled

    'View Menu
    Menu Add PopUp, hMenu, "&View",    hMenuView,    %MF_Enabled
    Menu Add String, hMenuView, "1 Left Beside Right over Bottom, Bottom Left-to-Right", %IDM_1, %MF_Enabled
    Menu Add String, hMenuView, "2 Left over Bottom - Right Top-to-Bottom", %IDM_2, %MF_Enabled
    Menu Add String, hMenuView, "3 Left Beside Right, No Bottom", %IDM_3, %MF_Enabled
    Menu Add String, hMenuView, "4 Left Beside Right under Bottom, Bottom Left-to-Right", %IDM_4, %MF_Enabled
    Menu Add String, hMenuView, "5 Right over Bottom - Left Top-to-Bottom", %IDM_5, %MF_Enabled
    Menu Add String, hMenuView, "6 Left over Right, No Bottom", %IDM_6, %MF_Enabled
    Menu Add String, hMenuView, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hMenuView, "Fixed Position Splitter Bars", %IDM_Fixed, %MF_Enabled

    'Actions Menu
    Menu Add PopUp, hMenu, "&Actions", hMenuActions, %MF_Enabled
    Menu Add String, hMenuActions, "&Select Background Color", %IDM_SelectBackground, %MF_Enabled
    Menu Add String, hMenuActions, "&Reset Splitter", %IDM_ResetSplitter, %MF_Enabled
    Menu Add String, hMenuActions, "Set &Password", %IDM_SetPassword, %MF_Enabled
    Menu Add String, hMenuActions, "&Clear Password", %IDM_ClearPassword, %MF_Enabled
    Menu Add String, hMenuActions, "Clear &MRU List", %IDM_ClearOpenMRU, %MF_Enabled
'    Menu Add String, hMenuActions, "Shell To ...", %IDM_ShellTo, %MF_Enabled
         Menu New PopUp To hMenuShell
         Menu Add PopUp, hMenuActions, "&Shell", hMenuShell, %MF_Enabled
         Menu Add String, hMenuShell, "&DOS", %IDM_ShellDOS, %MF_Enabled
         Menu Add String, hMenuShell, "&Open", %IDM_ShellOpen, %MF_Enabled
         Menu Add String, hMenuShell, "&Explorer", %IDM_ShellExplore, %MF_Enabled

    'Options Menu
    Menu Add PopUp, hMenu, "&Options", hMenuOptions, %MF_Enabled
    Menu Add String, hMenuOptions, "&Confirm Delete", %IDM_ConfirmDelete, %MF_Enabled
    Menu Add String, hMenuOptions, "&On Top", %IDM_OnTop, %MF_Enabled
    Menu Add String, hMenuOptions, "Single &Instance", %IDM_SingleInstance, %MF_Enabled
    Menu Add String, hMenuOptions, "Usage &Timer", %IDM_UserTimer, %MF_Enabled
    Menu Add String, hMenuOptions, "&Limit Size", %IDM_LimitSize, %MF_Enabled
    Menu Add String, hMenuOptions, "&Enable Voice Messages", %IDM_EnableVoice, %MF_Enabled
    Menu Add String, hMenuOptions, "&ToolbarText", %IDM_ToolbarText, %MF_Enabled
    Menu Add String, hMenuOptions, "&DisplayFileName", %IDM_DisplayFileName, %MF_Enabled


    'Tools Menu
    Menu Add PopUp, hMenu, "&Tools",   hMenuTools,   %MF_Enabled
    Menu Add String, hMenuTools, "&Calculator", %IDM_Calculator, %MF_Enabled
    Menu Add String, hMenuTools, "Character &Map", %IDM_CharacterMap, %MF_Enabled
    Menu Add String, hMenuTools, "&Ascii Table", %IDM_AsciiTable, %MF_Enabled
    Menu Add String, hMenuTools, "-", %IDM_Sep, 0
    Menu Add String, hMenuTools, "&Dialog Capture", %IDM_DialogCapture, %MF_Enabled
    Menu Add String, hMenuTools, "&Screen Capture", %IDM_ScreenCapture, %MF_Enabled

    'Help Menu
    Menu Add PopUp, hMenu, "&Help", hMenuHelp, %MF_Enabled
    Menu Add String, hMenuHelp, "&Help Contents", %IDM_HelpFile, %MF_Enabled
    Menu Add String, hMenuHelp, "&Email Author", %IDM_EmailAuthor, %MF_Enabled
    Menu Add String, hMenuHelp, "&Web Site", %IDM_WebSite, %MF_Enabled
    Menu Add String, hMenuHelp, "-", %IDM_Sep, 0
    Menu Add String, hMenuHelp, "&About", %IDM_About, %MF_Enabled

    Menu Attach hMenu, hDlg
End Sub

Sub CreateContextMenu
     Menu New PopUp To hContext
     Menu Add String, hContext, "Cut",  %IDP_Cut,  %MF_Enabled
     Menu Add String, hContext, "Copy", %IDP_Copy, %MF_Enabled
     Menu Add String, hContext, "Paste",  %IDP_Paste,  %MF_Enabled
     Menu Add String, hContext, "Delete", %IDP_Delete,  %MF_Enabled
     Menu Add String, hContext, "CopyAll", %IDP_CopyAll,  %MF_Enabled
End Sub

Sub CreateToolbarDropDownMenu
   Menu New PopUp To hDropDown
   Menu Add String, hDropDown, "DOS", %IDT_ShellDOS, %MF_Enabled
   Menu Add String, hDropDown, "Open", %IDT_ShellOpen, %MF_Enabled
   Menu Add String, hDropDown, "Explore", %IDT_ShellExplore, %MF_Enabled
End Sub

Sub BuildAcceleratorTable
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(5)
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_O : ac(c).cmd   = %IDM_Open       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_N : ac(c).cmd   = %IDM_New        : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_S : ac(c).cmd   = %IDM_Save       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_F : ac(c).cmd   = %IDT_Find       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_P : ac(c).cmd   = %IDM_Print      : Incr c
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F3 : ac(c).cmd   = %IDT_Find      : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub


' Toolbar ==============================================================================
' gbSnippets:  gbs_00104  gbs_00294  gbs_00288  gbs_00112  gbs_00291
Sub CreateToolbar

    Local iReturn As Long
    Local hBMP, hLst As Dword

    Menu Get State hMenuOptions, ByCmd %IDM_ToolbarText To iReturn   'get the state

    Control Add Toolbar, hDlg, %IDC_Toolbar, "Toolbar",0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat
    Control Send hDlg, %IDC_Toolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS   'allow dropdown arrow buttons
    Control Handle hDlg, %IDC_Toolbar To hToolbar

    'a toolbar has a built-in imagelist, to which programmers can add images
    'or they can create an imagelist from scratch.

    If 0 Then
        'use built-in images for toolbar
        'add standard bitmaps to imagelist
        Dim BMP As TBADDBITMAP
        BMP.hInst = %HINST_COMMCTRL       'OEM system bitmaps (group of 15 images)
        BMP.nID = %IDB_STD_SMALL_COLOR
        Control Send hDlg, %IDC_Toolbar, %TB_ADDBITMAP, 0, VarPtr(BMP)

        'create buttons
        Toolbar Add Button  hDlg, %IDC_Toolbar, %STD_FileNew+1,    %IDT_New,    %TbStyle_Button, IIf$(iReturn, "New", "")
        Toolbar Add Button  hDlg, %IDC_Toolbar, %STD_FileOpen+1,   %IDT_Open,   %TbStyle_Button, IIf$(iReturn, "Open", "")
        Toolbar Add Button  hDlg, %IDC_Toolbar, %STD_FileSave+1,   %IDT_Save,   %TbStyle_Button, IIf$(iReturn, "Save", "")
        Toolbar Add Button  hDlg, %IDC_Toolbar, %STD_Print+1,      %IDT_Print,  %TbStyle_Button, IIf$(iReturn, "Print", "")
        Toolbar Add Separator hDlg, %IDC_Toolbar, 10
        Toolbar Add Button  hDlg, %IDC_Toolbar, %STD_Cut+1,        %IDT_Cut,    %TbStyle_Button, IIf$(iReturn, "Cut", "")
        Toolbar Add Button  hDlg, %IDC_Toolbar, %STD_Copy+1,       %IDT_Copy,   %TbStyle_Button, IIf$(iReturn, "Copy", "")
        Toolbar Add Button  hDlg, %IDC_Toolbar, %STD_Paste+1,      %IDT_Paste,  %TbStyle_Button, IIf$(iReturn, "Paste", "")
        Toolbar Add Button  hDlg, %IDC_Toolbar, %STD_Delete+1,     %IDT_Delete, %TbStyle_Button, IIf$(iReturn, "Delete", "")
        Toolbar Add Separator hDlg, %IDC_Toolbar, 10
        Toolbar Add Button  hDlg, %IDC_Toolbar, %STD_Properties+1, %IDT_Shell,  %TbStyle_DropDown, IIf$(iReturn, "Shell To..", "")
        Toolbar Add Separator hDlg, %IDC_Toolbar, 10
        Toolbar Add Button  hDlg, %IDC_Toolbar, %STD_Help+1,       %IDT_Help,   %TbStyle_Button, IIf$(iReturn, "Help", "")
    Else
        'use resource images for toolbar
        'create imagelist
        ImageList New Icon 16,16,32,3 To hLst
        ImageList Add Icon hLst, "new"                     '1
        ImageList Add Icon hLst, "open"                    '2
        ImageList Add Icon hLst, "save"                    '4
        ImageList Add Icon hLst, "print"                   '3
        ImageList Add Icon hLst, "cut"                     '5
        ImageList Add Icon hLst, "copy"                    '6
        ImageList Add Icon hLst, "paste"                   '7
        ImageList Add Icon hLst, "delete"                  '8
        ImageList Add Icon hLst, "props"                   '9
        ImageList Add Icon hLst, "help"                    '10
        'attach imagelist
        Toolbar Set ImageList hDlg, %IDC_Toolbar, hLst, 0

        'create buttons
        Toolbar Add Button  hDlg, %IDC_Toolbar,  1, %IDT_New,    %TbStyle_Button, IIf$(iReturn, "New", "")
        Toolbar Add Button  hDlg, %IDC_Toolbar,  2, %IDT_Open,   %TbStyle_Button, IIf$(iReturn, "Open", "")
        Toolbar Add Button  hDlg, %IDC_Toolbar,  3, %IDT_Save,   %TbStyle_Button, IIf$(iReturn, "Save", "")
        Toolbar Add Button  hDlg, %IDC_Toolbar,  4, %IDT_Print,  %TbStyle_Button, IIf$(iReturn, "Print", "")
            Toolbar Add Separator hDlg, %IDC_Toolbar, 10
        Toolbar Add Button  hDlg, %IDC_Toolbar,  5, %IDT_Cut,    %TbStyle_Button, IIf$(iReturn, "Cut", "")
        Toolbar Add Button  hDlg, %IDC_Toolbar,  6, %IDT_Copy,   %TbStyle_Button, IIf$(iReturn, "Copy", "")
        Toolbar Add Button  hDlg, %IDC_Toolbar,  7, %IDT_Paste,  %TbStyle_Button, IIf$(iReturn, "Paste", "")
        Toolbar Add Button  hDlg, %IDC_Toolbar,  8, %IDT_Delete, %TbStyle_Button, IIf$(iReturn, "Delete", "")
            Toolbar Add Separator hDlg, %IDC_Toolbar, 10
        Toolbar Add Button  hDlg, %IDC_Toolbar,  9, %IDT_Shell,  %TbStyle_DropDown, IIf$(iReturn, "Shell To..", "")
        Toolbar Add Separator hDlg, %IDC_Toolbar, 10
        Toolbar Add Button  hDlg, %IDC_Toolbar, 10, %IDT_Help,   %TbStyle_Button, IIf$(iReturn, "Help", "")
    End If
End Sub


'Controls ==============================================================================
'  gbSnippets:  see the complete sections called "Controls", "Controls-Techniques", and "TreeView Control"
Sub CreateControls
   Local Style As Long
   Local hItem As Dword
    'add the controls + splitter bars (labels)
    Control Add Statusbar, hDlg, %IDC_StatusBar, "",0,0,0,0     'xy, xxyy ignored, %ccs_bottom by default

    Style = %WS_TabStop Or %TVS_HasButtons Or %TVS_LinesAtRoot Or %TVS_HasLines Or %TVS_ShowSelAlways Or %WS_Border
    Control Add Treeview, hDlg, %IDC_Left, "TopLeft",  20, 55, 170, 100, Style, %WS_Ex_Left
       Treeview Insert Item hDlg, %IDC_Left, 0, %TVI_Last, 1,1,"c:\" To hItem
       Treeview Insert Item hDlg, %IDC_Left, hItem, %TVI_Last, 1,4,"n/a" To hItem

    Control Add ListView, hDlg, %IDC_Bottom, "",  20, 185, 370, 90, %LVS_Report Or %LVS_ShowSelAlways Or %WS_TabStop Or %LVS_SingleSel, %WS_Ex_ClientEdge Or %WS_Ex_Left
       'columns               hdlg, id&, col, "test", width, format
       ListView Insert Column hDlg, %IDC_Bottom, 1, "Name", 300, 0
       ListView Insert Column hDlg, %IDC_Bottom, 2, "Size", 125, 0
       ListView Insert Column hDlg, %IDC_Bottom, 3, "Date", 150, 0
       ListView Insert Item hDlg, %IDC_Bottom, 1, 1, "<no files>"  'row 1, col1

'   Style = %WS_Child Or %WS_Visible Or %ES_MultiLine Or %WS_VScroll Or %ES_AutoHScroll _
'             Or %WS_HScroll Or %ES_AutoVScroll Or %ES_WantReturn Or %ES_NoHideSel Or %WS_TabStop Or %WS_Border
   Style = %WS_Child Or %WS_Visible Or %ES_MultiLine Or %WS_VScroll _
             Or %ES_AutoVScroll Or %ES_WantReturn Or %ES_NoHideSel Or %WS_TabStop Or %WS_Border
    Control Add TextBox, hDlg, %IDC_Right, "TopRight", 220, 55, 170, 100, Style
       Control Handle hDlg, %IDC_Right To hRightTextBox

    Control Add Label, hDlg, %IDC_LabelH, "",  200, 45, 6, 125, %SS_Notify , %WS_Ex_ClientEdge  ' up/down - does horizontal split
    Control Add Label, hDlg, %IDC_LabelV, "",  0,170, 410, 6, %SS_Notify , %WS_Ex_ClientEdge   ' left/right - does vertical split
    Control Set Color hDlg, %IDC_LabelV, %Black, %Red
    Control Set Color hDlg, %IDC_LabelH, %Black, %Blue
End Sub


'File/Folder Browser ====================================
'  gbSnippets:  gbs_00525  gbs_00526
Sub DisplayChildren (hParent As Dword)   'fills out Treeview with subfolders of selected node
   Local hChild, hTemp As Dword
   Local ChildDIR, ParentDIR, temp As String
   Local FullPath As String

   'get text of parent node that is is expanding
   Treeview Get Text hDlg, %IDC_Left, hParent To ParentDIR
   ParentDIR = Trim$(ParentDIR, "\")

   'remove all children
   Do
      Treeview Get Child hDlg, %IDC_Left, hParent To hChild
      If hChild Then Treeview Delete hDlg, %IDC_Left, hChild
   Loop While hChild

   'add nodes for each subfolder
   ChildDir = Dir$(FullTreePath(hParent) + "\*.*", Only %SubDir)
   While Len(ChildDIR)
      Treeview Insert Item hDlg, %IDC_Left, hParent, %TVI_Last, 0, 0, ChildDIR To hTemp
      ChildDIR = Dir$
   Wend

   'add dummy child to each tree element whose folder has subfolders
   Treeview Get Child hDlg, %IDC_Left, hParent To hChild
   While hChild
      FullPath = FullTreePath(hChild)
      temp = Dir$(FullPath + "\*.*", Only %SubDir)
      If Len(temp) Then Treeview Insert Item hDlg, %IDC_Left, hChild, %TVI_Last, 0, 0, "n/a" To hTemp
      Treeview Get Next hDlg, %IDC_Left, hChild To hChild
   Wend
End Sub

Function FullTreePath(ByVal hNode As Dword) As String    'get full path of selected node
   'get full directory path for hNode
   Local FullPath, temp As String
   Do
      Treeview Get Text hDlg, %IDC_Left, hNode To temp
      FullPath = "\" + temp + FullPath
      Treeview Get Parent hDlg, %IDC_Left, hNode To hNode
   Loop Until hNode = 0
   Replace "\\" With "\" In FullPath
   Function = LTrim$(FullPath, "\")
End Function

Sub DisplayFiles        'put subfolder file list in ListView control
   Local temp As String
   Local hNode As Dword
   Local Count As Long
   Local D As DirData, lft As FileTime, st As SystemTime

   ListView Reset hDlg, %IDC_Bottom
   ListView Insert Item hDlg, %IDC_Bottom, 1, 0, Str$(Count)
   Treeview Get Select hDlg, %IDC_Left To hNode
   temp = Dir$(FullTreePath(hNode)+"\*.*", To D)
   If Len(temp) Then ListView Reset hDlg, %IDC_Bottom
   Do
      If Len(temp) Then
         Incr Count
         ListView Insert Item hDlg, %IDC_Bottom, 1, 0, temp
         ListView Set Text hDlg, %IDC_Bottom, 1,2, Format$(D.FileSizeHigh * &H100000000 + D.FileSizeLow, "###,###,##0")

         FileTimeToLocalFileTime(ByVal VarPtr(D.LastWriteTime), lft)
         FileTimeToSystemTime(lft, st)
         ListView Set Text hDlg, %IDC_Bottom, 1,3, _
               Format$(st.wMonth, "##")+"/"+Format$(st.wDay, "00")+"/"+Format$(st.wYear) + " " + _
               Format$(st.wHour, "##")+":"+Format$(st.wMinute, "00")+":"+Format$(st.wSecond)
      End If
      temp = Dir$(Next, To D)
   Loop While Len(temp)
   ListView Sort hDlg, %IDC_Bottom, 1, Ascend
   End Sub

'SubClassing (new window procedure) ==============================================
'  gbSnippets:  gbs_00107  gbs_00309  gbs_00129  gbs_00138  gbs_00224  gbs_00285
Function RightTextBoxProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long
   Select Case Msg
      Case %WM_ContextMenu
         x = Lo(Word,lParam) : y = Hi(Word, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContext, %TPM_LEFTALIGN, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OldProc, hWnd, Msg, wParam, lParam)
End Function

'About Dialog =============================================================================
'  gbSnippets:  gbs_00035
Sub DisplayAboutDialog()
    'this defines the about Dialog. Note the icon selection, multiple fonts, and ImageX
    'control used to display an image
     Local hAboutFont1, hAboutFont2 As Dword
     Local Buffer As String

     Dialog New Pixels, hDlg, "About gbTemplate", 100, 100, 280, 175, %WS_SysMenu Or %WS_Caption Or %WS_ClipChildren To hAbout
     Dialog Set Icon hAbout, "aainfo"
     Font New "MS Sans Serif", 14, 1 To hAboutFont1
     Font New "MS Sans Serif", 9, 1 To hAboutFont2

     Control Add Label, hAbout, %IDC_LabelVersion, "gbTemplate", 10, 10, 260, 30, %SS_Center

     Buffer = String$(200,0) : LoadString GetModuleHandle(""), 2, ByVal StrPtr(Buffer), Len(Buffer)
     Control Add Label, hAbout, %IDC_LabelWebSite, "Gary Beene's Information Center", 10, 50, 260, 15, %SS_Center

     Buffer = String$(200,0) : LoadString GetModuleHandle(""), 3, ByVal StrPtr(Buffer), Len(Buffer)
     Control Add Label, hAbout, %IDC_LabelURL, "http://www.garybeene.com", 10, 70, 260, 15, %SS_Center Or %SS_Notify

     Control Set Font hAbout, %IDC_LabelVersion, hAboutFont1
     Control Set Font hAbout, %IDC_LabelWebSite, hAboutFont2
     Control Set Font hAbout, %IDC_LabelURL, hAboutFont2

     Control Add ImageX, hAbout, %IDC_AboutImage,"garyface", 10,100,259,66, %SS_Notify

     Dialog Show Modal hAbout Call AboutProc()
     Font End hAboutFont1
     Font End hAboutFont2
End Sub

CallBack Function AboutProc() As Long
   'this is the Callback function for the About dialog. It changes the URL color
   'when the mouse is over that label. It also captures the mouse click and opens
   'a URL in the default browser (using the ShellExecute API).
    Local URL As Asciiz * %Max_Path, iReturn As Long
    Select Case Cb.Msg
       Case %WM_Command
          If Cb.Ctl = %IDC_LabelURL And Cb.CtlMsg = %STN_Clicked Then
            URL$ = "http://www.garybeene.com/"
            iReturn = ShellExecute(hDlg, "Open", URL, $Nul, $Nul, %SW_ShowNormal)
          End If
       Case %WM_SetCursor
          Window Get Id Cb.WParam To iReturn
          Select Case iReturn   'GetDlgCtrlID (CB.wParam)
             Case %IDC_LabelURL
                Control Set Color hAbout, %IDC_LabelURL, %Red, -1
                Dialog ReDraw hAbout
             Case Else
                Control Set Color hAbout, %IDC_LabelURL, %Black, -1
                Dialog ReDraw hAbout
          End Select
   End Select
End Function

'MRU (Most Recently Updated) ============================================================
'  gbSnippets:  gbs_00046
Sub AddFileToOpenMRUArray(NewPath As String)
   Local i As Long
   NewPath = LCase$(NewPath)              'work in lower case
   Array Scan OpenMRU(), = NewPath,  To i  'scan for duplicate of NewPath$
   If i Then Array Delete OpenMRU(i-1)      'remove duplicate, if found
   Array Insert OpenMRU(0), NewPath        'put newpath$ at top of array OpenMRU()
End Sub

Sub ClearOpenMRUList
   Local i As Long
   ReDim OpenMRU(9)              'clear the array containing OpenMRU file names
   Menu Delete hMenuFile, 8     'remove the separator after Exit
   For i = 0 To 9 : Menu Delete hMenuFile, ByCmd 251+i : Next i 'remove the hMenu items
End Sub

Sub PutOpenMRUListInFileMenu
   Local i As Long

   'delete all MRU entries from File menu
   Menu Delete hMenuFile, 8                    'remove existing separator after Exit
   For i = 0 To 9 : Menu Delete hMenuFile, ByCmd 251+i : Next i 'remove existing MRU entries

   'add the array of MRU values, plus the separator
   If OpenMRU(0) <> "" Then Menu Add String, hMenuFile, "-", 0, 0  'add sep after Exit only if MRUs exist
   For i = 0 To 9
      If Len(OpenMRU(i)) Then
         Menu Add String, hMenuFile, OpenMRU(i), 251+i, %MF_Enabled
      End If
   Next i
End Sub

'File New/Open ==============================================================
'  gbSnippets:  gbs_00118
Sub OpenNewFileName (FileNameToOpen As String, InStartup As Long)
    Local Style As Long
    Local NewPassword As String
    Style = %MB_YesNoCancel + %MB_IconQuestion + %MB_TaskModal

    If FileChanged Then
       Select Case MsgBox ("File has changed. Save Changes?", Style, "Open File")
          Case %IdYes
             SaveCurrentFile  'save changes, continue
          Case %IdNo
                              'not save changes, continue
          Case %IdCancel
             Exit Sub    'Not Save Changes, do not open file
       End Select
   End If

   'verify that the new name exists, and if a file
   If IsFile(FileNameToOpen) = %False Then
      If (FileNameToOpen = "<untitled>") Or InStartup Then
         OpenUntitledFileName
      End If
      Exit Sub
   End If

   'make sure that the new name is the right extension
   If InStr(".txt.bas.inc.jpg.gif.png.bmp", LCase$(Right$(FileNameToOpen,4))) = 0 Then
      If InStartup Then
        OpenUnTitledFileName
      End If
      Exit Sub
   End If

   If InStr(".jpg.gif.png.bmp", LCase$(Right$(FileNameToOpen,4)))  Then
      ImageName = FileNameToOpen
      DisplayImage
      Exit Sub
   End If

   'everything left is now a text file
   'if not encrypted, then go ahead and open it
   If IsEncrypted(FileNameToOpen) = %False Then
      CurrentFilePassword = ""
      CurrentFileName = FileNameToOpen
      OpenCurrentFileName
      Exit Sub
   End If

   'it is encrypted, so ask user for Password
   NewPassword = InputBox$ ("Enter encryption password:", "Set Encryption Password", "")
   If Len(NewPassword) = 0 Then
      If InStartup Then
         'password not entered, so open up <untitled>
         OpenUntitledFileName
      Else
         'password not entered, so do nothing
      End If
   Else
      'password was entered, so use it
      CurrentFilePassword = NewPassword
      CurrentFileName = FileNameToOpen
      OpenCurrentFileName
   End If
End Sub

Sub OpenUntitledFileName
   Local iReturn As Long
   CurrentFileName = "<untitled>"  'temp name. program won't let you save a file with this name
   CurrentFilePassword = ""                 'no password
   Control Set Text hDlg, %IDC_Right, ""    'empty content
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Save, %TBState_Disabled
   FileChanged = 0
   Menu Get State hMenuOptions, ByCmd %IDM_DisplayFileName To iReturn   'get the state
   If iReturn Then Dialog Set Text hDlg, "gbTemplate     " + CurrentFileName  'set dialog caption
End Sub

Sub OpenCurrentFileName
   Local temp As String
   Local iReturn As Long
   Open CurrentFileName For Binary As #1
   Get$ #1, Lof(1), temp    'temp$ will contain $crlf's from the file
   Close #1                  'LOF() returns number of bytes in an Open file
   If Len(CurrentFilePassword) Then temp$ = EncryptMyString (Mid$(temp,15), CurrentFilePassword)
   Control Set Text hDlg, %IDC_Right, temp
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Save, %TBState_Disabled
   FileChanged = 0
   Menu Get State hMenuOptions, ByCmd %IDM_DisplayFileName To iReturn   'get the state
   If iReturn Then Dialog Set Text hDlg, "gbTemplate     " + CurrentFileName  'set dialog caption
   AddFileToOpenMRUArray CurrentFileName
   PutOpenMRUListInFileMenu      'reload Menu items
End Sub

Function IsEnCrypted (fName As String) As Long
   Local TestBytes As String * 10
   Open fName For Binary As #1
   Get #1, , TestBytes
   Close #1
   If TestBytes = "gbtEncrypt" Then
      Function = %True
   End If
End Function

Sub SelectFileToOpen
   Local filter$, startfile$, startfolder$
   Local defaultext$, flags&, filevar$, countvar&
   filter$ = Chr$("Text (*.txt,*.bas,*.inc)", 0, "*.txt;*.bas;*.inc", 0)
   startfolder$ = PathName$(Path, CurrentFileName)     'initial folder to be displayed
   If CurrentFileName <> "<untitled>" Then startfile$ = CurrentFileName    'name to be used as initial selection
   defaultext$ = "txt"                 'default extension to append to selection if user does not enter it
   flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
   Display Openfile hDlg, 100, 100, "", startfolder$, filter$, startfile$, _
                                  defaultext$, flags& To filevar$, countvar&
   If IsFile(filevar$) Then
      OpenNewFileName filevar$, 0
   Else
      SpeakToMe "No file selected!", 0
   End If
End Sub


' Image viewer dialog  ============================================================
'  gbSnippets:  gbs_00527
Sub DisplayImage
   ColorMarker = RGB(255,250,245)
   Dialog New Pixels, hDlg, "Image Viewer", 100, 100, 200, 200, %WS_ThickFrame Or %WS_SysMenu To hImageDialog
   Control Add Graphic, hImageDialog, %IDC_Graphic, "",0,0,200,200
      Graphic Attach hImageDialog, %IDC_Graphic
      Graphic Get DC To hDC_Graphic
   Control Add ListView, hImageDialog, %IDC_ListView, "",400,0,2000,2000, %LVS_SmallIcon
      Control Handle hImageDialog, %IDC_ListView To hListView
   Dialog Show Modeless hImageDialog Call DisplayImageProc
End Sub

CallBack Function DisplayImageProc() As Long
   Select Case Cb.Msg
      Case %WM_InitDialog
         LoadBackgroundImage
         SetTimer(hImageDialog, %ID_ImageTimer, 100&, %NULL)    'sends %WM_Timer to dialog callback
      Case %WM_Timer
         KillTimer hImageDialog, %ID_ImageTimer
         CopyListView
   End Select
End Function

Sub LoadBackgroundImage
   Local lvbi As LVBKIMAGE, szFile As Asciiz*%MAX_PATH
   Control Send hImageDialog, %IDC_ListView, %LVM_SetBkColor, 0, ColorMarker   'set background color
   szFile = ImageName
   lvbi.ulFlags = %LVBKIF_STYLE_NORMAL Or %LVBKIF_SOURCE_URL
   lvbi.pszImage = VarPtr(szFile)
   lvbi.cchImageMax = Len(szFile)
   Control Send hImageDialog, %IDC_ListView,  %LVM_SetBkImage, 0, VarPtr(lvbi)
End Sub

Sub CopyListView
   Local hMemDC,hBMP, hMemOld, hDeskTopDC As Dword
   Local w,h,x,y,iResult As Long
   Dialog Get Client hImageDialog To w,h
   hDeskTopDC = GetDC(%Null)
   hMemDC = CreateCompatibleDC(hDeskTopDC)            'memory DC
   hBMP = CreateCompatibleBitmap(hDeskTopDC, 2000,2000) 'memory bitmap same size as ListView
   ReleaseDC(%Null, hDeskTopDC)
   hMemOld = SelectObject(hMemDC, hBMP)         'select bitmap into memory DC
   Control Send hImageDialog, %IDC_Listview, %WM_Print, hMemDC, %PRF_Client Or %PRF_EraseBkGnd
   Control ReDraw hImageDialog, %IDC_Listview
   Do : iResult = GetPixel(hMemDC,x,0) : Incr x : Loop Until iResult = ColorMarker : x = x - 1
   Do : iResult = GetPixel(hMemDC,0,y) : Incr y : Loop Until iResult = ColorMarker : y = y - 1
   If x < 201 And y < 201 Then
      BitBlt hDC_Graphic, (w-x)/2,(h-y)/2,x,y, hMemDC, 0,0, %SRCCopy 'copy memory DC to Graphic Control DC
   Else
      If x <= y Then
         StretchBlt hDC_Graphic, (w-w*x/y)/2,0,w*x/y,h, hMemDC, 0,0,x,y, %SRCCopy 'copy memory DC to Graphic Control DC
      Else
         StretchBlt hDC_Graphic, 0,(h-h*y/x)/2,w,h*y/x, hMemDC, 0,0, x, y, %SRCCopy 'copy memory DC to Graphic Control DC
      End If
   End If
   Dialog Set Text hImageDialog, Str$(x) + " x " + Str$(y)
   hMemOld = SelectObject(hMemDC, hMemOld)         'unselect bitmap out of memory dc
   DeleteDC(hMemDC)                             'free the DC
   DeleteObject (hBMP)
   Graphic ReDraw
End Sub


'File Save =============================================================================
'  gbSnippets:  gbs_00120  gbs_00142
Sub SaveFileAs
   Local hParent As Dword
   Local title$, folder$, filter$, start$, defaultext$, flags&, filevar$, countvar&
   hParent = hDlg              'if not parent, use 0 or %hWnd_Desktop
   title$ = "Save File As"     'if "", then "Save As" is used
   folder$ = CurrentFileName   'if "", Then current directory is used
   filter$ = Chr$("Text", 0, "*.txt;*.bas;*.inc", 0)
      'filter$ consists of pairs of $Nul terminated description/pattern values
      'filter$ = Chr$("Text", 0, "*.txt", 0)    'same as:  "BASIC" + $Nul + "*.bas" + $Nul
      'filter$ example:    Chr$("All Files", 0, "*.*", 0)
      'filter$ example:    Chr$("Bitmap Files", 0, "*.bmp", 0, "All Files", 0, "*.*", 0)
   start$ = CurrentFileName    'starting filename
   defaultext$ = "txt"
   flags& = %OFN_PathMustExist Or %OFN_Explorer Or %OFN_OverWritePrompt
   Display Savefile hParent, 100, 100, "Save File", folder$, filter$, start$, _
                                     defaultext$, flags& To filevar$, countvar&
   '  filevar$ contains name of filename to use for Save
   '  countvar$ contains number of files selected
   '  if no file is selected, filevar$ = ""
   If Len(filevar$) Then
      'If ConfirmOverWrite(filevar$) Then   'not required since flags include OFN_OverwritePrompt
         CurrentFileName = filevar$
         SaveCurrentFile
      'End If
   End If
End Sub

Function ConfirmOverWrite (sFileName As String) As Long  '-1 approval, 0 not approved
   If IsFile(sFileName) Then
      'file exists. ask user for permission to overwrite
      Select Case MsgBox ("File exists. Overwrite?", %MB_OkCancel Or %MB_IconQuestion, "Save")
         Case %IdOk
            Function = %True
         Case %IdCancel
            Function = %False
      End Select
   Else
      Function = %True   'if file does not exist, permission is granted to create it
   End If
End Function

Sub SaveCurrentFile
   'do not allow saving file whose name is "NoName.txt" - reserved for gbTemplate
   If CurrentFileName = "<untitled>" Then
      SaveFileAs
      Exit Sub
   End If

   'go ahead and save the file, with encryption if Len(Password) > 0
   Local temp As String
   Control Get Text hDlg, %IDC_Right To temp
   Open CurrentFileName For Output As #1
   If Len(CurrentFilePassword) Then
      Print #1, "gbtEncrypt" + EncryptMyString(temp, CurrentFilePassword)
   Else
      Print #1, temp$
   End If
   Close #1
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Save, %TBState_Disabled
   FileChanged = 0
End Sub

'Speech Synthesis ===================================================================
'  gbSnippets:  gbs_00210  gbs_00483
Sub SpeakToMe (Message As String, iDelay As Long)
  Local iReturn As Long
  Menu Get State hMenuOptions, ByCmd %IDM_EnableVoice To iReturn   'get the state
  If iReturn Then
     VoiceMessage = Message
     Thread Create TalkThread(0) To hThread       'start the new thread, argument not used
     Thread Close hThread To hThread    'suggested by PowerBASIC Inc. as good practice
     Sleep iDelay
  End If
End Sub

Thread Function TalkThread(ByVal x As Long) As Long
    Local iReturn As Long
    Menu Get State hMenuOptions, ByCmd %IDM_EnableVoice To iReturn   'get the state
    If iReturn = 0 Then Exit Function

    'uses Global text$ value
    Local vRes, vTxt, vTime As Variant, oSp As Dispatch
    Set oSp = New Dispatch In "SAPI.SpVoice"
    If IsFalse IsObject(oSp) Then Exit Function
    vTxt = VoiceMessage
    Object Call oSp.Speak(vTxt) To vRes
    vTime = -1 As Long
    Object Call oSp.WaitUntilDone(vTime) To vRes
End Function

' Printing ===============================================================================
'  gbSnippets:  gbs_00119  gbs_00212  gbs_00300  gbs_00528  gbs_00301  gbs_00302
Sub SelectPrinter
      Local OldPrinter$
      OldPrinter$ = XPrint$    'XPrint$ returns the currently Attached printer
      XPrint Attach Choose
      If Len(XPrint$) Then
         PrintCurrentFile
      Else
         VoiceMessage = "Printing cancelled!"
         XPrint Attach OldPrinter$   'restores the printer connection wich ESC/Cancel breaks
      End If
End Sub

Sub PrintCurrentFile
    'Actually, this prints the content of %IDC_Right textbox, not the contents of the file
    'XPrint Attach was done before getting to this point
    Local i,j As Long
    Local temp As String

    Control Get Text hDlg, %IDC_Right To temp

    Dim PrintArray(ParseCount(temp, $CrLf)-1) As String
    Parse temp, PrintArray(), $CrLf                       'split text into array of Sstrings

'   SetPrinterScaleToInches w,h
    XPrint : XPrint
    For i = 0 To UBound(PrintArray)
       'PrintSingleTextLineWithTabs PrintArray(i)
       XPrint PrintArray(i)             'alternative way to print each line
       Incr j
       If j > 50 Then XPrint FormFeed: j=0 : XPrint : XPrint
    Next i
    If j Then XPrint FormFeed
End Sub

Sub PrintSingleTextLineWithTabs (temp As String)
   Local i As Long
   Local x,y As Single

   Dim TabLoc(25) As Single     '8.5 page = 17 Tabs, so 25 should be overkill
   For i = 0 To UBound(TabLoc) : TAbLoc(i) = i * 0.5 : Next i   '0.5" tab locations for printing

   For i = 1 To ParseCount(temp, $Tab)
      XPrint Parse$(temp,$Tab, i) ;
      XPrint Get Pos To x,y
      XPrint Set Pos (TabLoc((Fix(x/0.5)+1)),y)
   Next i
   XPrint
End Sub

Sub SetPrinterScaleToInches (ncWidth As Single, ncHeight As Single)
   Local x,y As Long
   XPrint Get Client To ncWidth!, ncHeight!  'Retrieve the client size (printable area) of the printer page
   XPrint Get PPI To x, y                  'Retrieve the resolution (points per inch) of the attached printer
   ncWidth = ncWidth/x                    'Width in inches of the printable area
   ncHeight = ncHeight/y                    'Height in inches of the printable area
   XPrint Scale (0,0)-(ncWidth,ncHeight)    'Set scale to inches
End Sub

' Encryption ==============================================================================
'  gbSnippts:  gbs_00234
Function EncryptMyString(text$, Psw$) As String
   Local i As Long, a As Long, temp$
   For i = 1 To Len(text$)
         a = i Mod Len(Psw$)
         If a = 0 Then a = Len(Psw$)
         Mid$(temp$,i) = (Chr$(Asc(Mid$(Psw$,a,1)) Xor Asc(Mid$(text$,i,1))))
   Next i
   Function = temp$
End Function

Function AskUserForPassword() As String
   Local temp As String
   Local x,y,w,h As Long
   Dialog Get Loc hDlg To x,y
   Dialog Get Size hDlg To w,h
   x = x + (w-300)/2         '300 is approximate width of InputBox
   y = y + (h-225)/2         '255 is approximate width of InputBox
   temp = InputBox$ ("Enter encryption password:", _
          "Set Encryption Password", CurrentFilePassword$, x, y)
   If Len(temp$) Then CurrentFilePassword = temp
End Function

' Cut/Copy/Paste/Delete ==================================================================
'  gbSnippets:  gbs_00081
Sub CutText
   CopyText
   'remove selected text (if any). leave cursor where removed text was found
   Control Send hDlg, %IDC_Right, %EM_ReplaceSel, 1, %Null    '1 means can be undone
End Sub

Sub CopyText
   'copies only selelcted text. if no selection, do nothing
   Local temp As String
   Local iStartPos, iStopPos As Long
   Control Send hDlg, %IDC_Right, %EM_GetSel, VarPtr(iStartPos), VarPtr(iStopPos) 'get start/stop position of selection
   If iStartPos = iStopPos Then Beep : Exit Sub                                   'no selection, so Exit

   'selection exists, so put on clipboard
   Clipboard Reset
   Control Get Text hDlg, %IDC_Right To temp
   Clipboard Set Text Mid$(temp, iStartPos+1, iStopPos - iStartPos)
End Sub

Sub PasteText
   'pastes whatever text is on the clipboard
   Local tempz As Asciiz * 1000
   Clipboard Get Text To tempz
   If Len(tempz) = 0 Then Beep : Exit Sub        'no selection so Exit
   'clipboard content found, so replace selection with text from clipboard
   Control Send hDlg, %IDC_Right, %EM_ReplaceSel, 1, VarPtr(tempz)
End Sub

Sub CopyAllText
   'copies all text, not just selected text
   Local temp As String
   Control Get Text hDlg, %IDC_Right To temp
   Clipboard Reset
   Clipboard Set Text temp
End Sub

Sub DeleteText
   'deletes selected text only
   Local iReturn As Long
   Menu Get State hMenuOptions, ByCmd %IDM_ConfirmDelete To iReturn   'get the state
   If iReturn Then
      If MsgBox("Are you sure?", %MB_OkCancel Or %MB_IconQuestion Or %MB_TaskModal, "Delete") = %IdCancel Then Exit Sub
   End If
   'remove selected text (if any). leave cursor where removed text was found
   Control Send hDlg, %IDC_Right, %EM_ReplaceSel, 1, %Null    '1 means can be undone
End Sub

' Drag/Drop Files ================================================================
'  gbSnippets:  gbs_00041
Function GetDroppedFileName(hDrop As Dword) As String
   'David Gwillim July 2005
   Local fString As Asciiz*%MAX_PATH, Count As Long
   fString=Space$(%MAX_PATH)
   Count = DragQueryFile(hDrop,0,fString,Len(fString)-1)  ' put FileName(0) into fString and get character count
   Function = Left$(fString,Count)                        ' put Count chars into result string
End Function


' Miscellaneous Features ==========================================================
'  gbSnippets:  gbs_00260  gbs_00261  gbs_00044  gbs_00036
Sub SetUserTimer
   Local iReturn As Long
   TimerCounter = 0
   Menu Get State hMenuOptions, ByCmd %IDM_UserTimer To iReturn   'get the state
   If iReturn Then
      SetTimer(hDlg, %ID_UsageTimer, TimerInterval, %NULL)    'sends %WM_Timer to dialog callback
      Statusbar Set Text hdlg, %IDC_StatusBar, 3, 0, "  0:00"
   Else
      KillTimer hDlg, %ID_UsageTimer
      Statusbar Set Text hdlg, %IDC_StatusBar, 3, 0, ""
   End If
End Sub

Sub SetOnTop
   Local iReturn, Flags As Long
   Menu Get State hMenuOptions, ByCmd %IDM_OnTop To iReturn   'get the state
   Flags = %SWP_NOMOVE Or %SWP_NOSIZE
   If iReturn Then
      SetWindowPos(hDlg, %HWND_TOPMOST, 0, 0, 0, 0, Flags)  'on Top
   Else
      iReturn = SetWindowPos(hDlg, %HWND_NOTOPMOST, 0, 0, 0, 0, Flags)  'not on Top
   End If
End Sub

Sub ShowASCIITable
   Local temp() As String, i As Long, all$
   Dim temp(32)
   For i = 0 To 31
      temp(i) = Space$(8) + Chr$(i+33) + Chr$(9) + Str$(i+33)
   Next i
   For i = 0 To 31
      temp(i) = temp(i) + Chr$(9) + Space$(8) + Chr$(i+65) + Chr$(9) + Str$(i+65)
   Next i
   For i = 0 To 31
      temp(i) = temp(i) + Chr$(9) + Space$(8) + Chr$(i+97) + Chr$(9) + Str$(i+97) + Chr$(9)
   Next i
   all$ = Join$(temp(), $CrLf)
   all$ = all$ + $CrLf + $CrLf + Space$(5) + " 0  null" + $Tab + $Tab + "12  formfeed (FF)"
   all$ = all$ + $CrLf + Space$(5) + " 8  backspace" + $Tab + "13  carriage return (CR)"
   all$ = all$ + $CrLf + Space$(5) + " 9  tab" + $Tab + $Tab + "27  escape (ESC)"
   all$ = all$ + $CrLf + Space$(5) + "10  linefeed (LF)" + $Tab + "32  space"
   MsgBox all$, %MB_Ok+%MB_IconInformation, "ASCII Table"
End Sub

Function InstanceTest() As Long
   'returns 0 if instance exits or cannot create mutex. otherwise returns 1.
   Local UniqueName As Asciiz * %Max_Path
   UniqueName = "gbTemplate"
   If CreateMutex(ByVal %Null, 0, UniqueName) = 0 _
         Or Err = %ERROR_ALREADY_EXISTS Then Exit Function Else Function = 1
'         Or GetLastError = %ERROR_ALREADY_EXISTS Then Exit Function Else Function = 1
End Function

Sub SetBackgroundColor
   Local ColorResult, Flags As Long
   Local Colors As CustomColors
   Flags& = %CC_PreventFullOpen
   Display Color hDlg, 100, 100, BackColor, Colors, Flags To ColorResult
   If ColorResult& = -1 Then
      'MsgBox "No color selected!"    'optional
   Else
      BackColor = ColorResult&        'BackColor is saved to INI file
      'use selected color
      Control Set Color hDlg, %IDC_Left, %Black, BackColor
      Control Set Color hDlg, %IDC_Right, %Black, BackColor
      Control Set Color hDlg, %IDC_Bottom, %Black, BackColor
      Dialog ReDraw hDlg
   End If
End Sub

Sub SetDialogCaption
   Local iReturn As Long
   Menu Get State hMenuOptions, ByCmd %IDM_DisplayFileName To iReturn   'get the state
   If iReturn Then
      Dialog Set Text hDlg, "gbTemplate     " + CurrentFileName
   Else
      Dialog Set Text hDlg, "gbTemplate"
   End If
End Sub

Sub CreateDefaultFile
   Local temp As String
      temp = "                           Welcome to gbTemplate"
      temp = temp + $CrLf + "gbTemplate demonstrates over 110 application/GUI features, including the ability to edit text files and to view image files. Use its source code as a "
      temp = temp + "starter skeleton for a new application or use it to learn how to use DDT, "
      temp = temp + "supplemented with a few API, to create feature-rich applications."
      temp = temp + $CrLf + $CrLf + "The source code is heavily commented, including cross-references to snippets "
      temp = temp + "found in the gbSnippets PowerBASIC source code library.  Those snippets "
      temp = temp + "contain additional source code and tutorial information on the features "
      temp = temp + "demonstrated by gbTemplate."
      temp = temp + $CrLf + $CrLf + "gbSnippets is available at   http://www.garybeene.com/sw/gbsnippets.htm"
   Open EXE.Path$ + "default.txt" For Output As #1
      Print #1, temp
   Close #1
End Sub


'Print Preview =============================================================================
Sub DisplayPrintPreviewDialog()
     Dialog New Pixels, hDlg, "Print Preview", 100, 100, 675, 500, %WS_OverlappedWindow Or %WS_ClipChildren To hPPDialog
     Dialog Set Icon hPPDialog, "print"

     Dialog New Pixels, hPPDialog, "", 0, 40, 50, 50, %DS_Control Or %WS_Child Or %WS_ClipChildren, 0 To hPPViewPort
     Dialog Set Color hPPViewPort, %Black, %rgb_LightGray
     Control Add Graphic, hPPViewPort, %IDC_PrintGraphicVisible, "", 0,0,50,50    ', %WS_Border Or %WS_TabStop
     Graphic Attach hPPViewPort, %IDC_PrintGraphicVisible

     Control Add Label, hPPDialog,  %IDC_PrintLineLabel, "print", 0,37,50,1, %WS_Border
     Control Add ImgButton, hPPDialog,  %IDC_PrinterSelect, "print", 5,5,25,25
     Control Add ImgButton, hPPDialog, %IDC_PrintPageSetup, "props", 35,5,25,25

     Control Add ImgButton, hPPDialog, %IDC_PrintLeft, "left", 75,5,25,25
     Control Add Label, hPPDialog, %IDC_PrintPageLabel, "01", 102,5,25,25, %WS_Border Or %SS_Center Or %SS_CenterImage Or %SS_Notify
     Control Set Color hPPDialog, %IDC_PrintPageLabel, %Black, %White
     Control Add ImgButton, hPPDialog, %IDC_PrintRight, "right", 129,5,25,25

     Control Add Button, hPPDialog,  %IDC_PrintAll, "Print All", 170,5,50,25
     Control Add Button, hPPDialog,  %IDC_PrintPage, "Print Page", 225,5,60,25

     Control Add Button, hPPDialog,  %IDC_PrintRange, "Print", 295,5,35,25
     Control Add TextBox, hPPDialog, %IDC_PrintMinPage, "1", 335,5,25,25
     Control Add Label, hPPDialog, %IDC_PrintRangeLabel, "to", 360,5,15,25, %SS_Center Or %SS_CenterImage Or %SS_Notify
     Control Add TextBox, hPPDialog, %IDC_PrintMaxPage, "1", 380,5,25,25

     Dim cmbData(7) As String
     Array Assign cmbData() = "Page", "Width", "25%", "50%", "75%", "100%", "200%", "400%"
     Control Add ComboBox, hPPDialog, %IDC_PrintZoom, cmbData() , 415,5,75,150, %CBS_DropDownList
     ComboBox Select hPPDialog, %IDC_PrintZoom, 1

     Control Add ImgButton, hPPDialog, %IDC_PrintOrientation, "refresh", 495,5,25,25
     Control Add ImgButton, hPPDialog, %IDC_PrintShowMargins, "margin", 525,5,25,25
     Control Add CheckBox, hPPDialog, %IDC_PrintHeader, "Header", 555,5,55,10
     Control Add CheckBox, hPPDialog, %IDC_PrintFooter, "Footer", 555,20,55,10
     Control Add Button, hPPDialog,  %IDC_PrintClose, "Cancel", 620,5,50,25

     'values needed for initialization
     Control Set Check hPPDialog, %IDC_PrintHeader, 1
     Control Set Check hPPDialog, %IDC_PrintFooter, 1
     PPCurrentPage = 1 : PPOrientation = 1
     PPMarginLeft = 1 : PPMarginRight = 1 : PPMarginTop = 1 : PPMarginBottom = 1
     PPShowFooter = 1  : PPShowHeader = 1 : PPZoom = 1
     PPwMax = 500 : PPhMax = 500 : PPhs=5 : PPvs=5

     'initialize properties and display content to be printed
     SetPrintPreviewProperties
     CreateHiddenGraphicControl   'create graphic controls according to orientation 1=portrait 0=landscape
     CreatePrintContent           'format all output text, place in PPPrintArray()
     PrintToHiddenGraphic         'display PPCurrentPage on the full size hidden graphic control
     PrintToVisibleGraphic        'shrink image from the hidden graphic control to the visible graphic control

     Dialog Show Modeless hPPViewPort, Call ViewPortProc
     Dialog Show Modal hPPDialog Call PreviewProc()
End Sub
CallBack Function PreviewProc() As Long
   'this is the Callback function for the Print Preview dialog.
    Local iReturn As Long
    Select Case Cb.Msg
       Case %WM_InitDialog
          CreateToolTipControl hPPDialog     'create handle hPPToolTip
          CreateToolTips
       Case %WM_Size
          'ScrollBarDisplay
          ResizeControls
          PrintToVisibleGraphic
       Case %WM_HScroll     : ScrollBarRespond %SB_Horz, Cb.WParam  'respond to horizontal scroll
       Case %WM_VScroll     : ScrollBarRespond %SB_Vert, Cb.WParam  'respond to vertical scroll
       Case %WM_Command
          Select Case Cb.Ctl
             Case %IDC_PrinterSelect  : XPrint Attach Choose : If Len(XPrint$) > 0 Then PrintRefresh
             Case %IDC_PrintPageSetup : PrintPageSetup
             Case %IDC_PrintPageLabel : PrintProperties
             Case %IDC_PrintAll       : SendToPrinter(0) : Dialog End hPPDialog
             Case %IDC_PrintPage      : SendToPrinter(1) : Dialog End hPPDialog
             Case %IDC_PrintRange     : SendToPrinter(2) : Dialog End hPPDialog
             Case %IDC_PrintClose     : Dialog End hPPDialog
             Case %IDC_PrintLeft
                 Decr PPCurrentPage
                 If PPCurrentPage < 1 Then PPCurrentPage = 1
                 PrintToHiddenGraphic : PrintToVisibleGraphic
             Case %IDC_PrintRight
                 Incr PPCurrentPage
                 If PPCurrentPage > PPMaxPages Then PPCurrentPage = PPMaxPages
                 PrintToHiddenGraphic : PrintToVisibleGraphic
             Case %IDC_PrintZoom
                 If Cb.CtlMsg = %LBN_SelChange Then
                    ComboBox Get Select hPPDialog, %IDC_PrintZoom To PPZoom '0-whole 1-pagewidth 2-.25 3-.50 4-.75 5-1.0 6-2.0 7-4.0
                    ResizeControls
                    PrintToVisibleGraphic
                 End If
             Case %IDC_PrintShowMargins
                 PPShowMargins = PPShowMargins Xor 1
                 PrintToHiddenGraphic : PrintToVisibleGraphic
             Case %IDC_PrintOrientation
                 PPOrientation = PPOrientation Xor 1
                 PrintRefresh
             Case %IDC_PrintHeader
                 PrintRefresh   'overkill.  resizecontrols, CreateHiddenGraphicControl are not necessary
             Case %IDC_PrintFooter
                 PrintRefresh   'overkill.  resizecontrols, CreateHiddenGraphicControl are not necessary
          End Select
    End Select
End Function

CallBack Function ViewPortProc() As Long
   Select Case Cb.Msg
       Case %WM_InitDialog
          ScrollBarInitialize
'          ShowScrollBar hPPViewPort, %SB_Both, PPScrollBarsVisible
       Case %WM_HScroll   : ScrollBarRespond %SB_Horz, Cb.WParam  'respond to horizontal scroll
       Case %WM_VScroll   : ScrollBarrespond %SB_Vert, Cb.WParam  'respond to vertical scroll
   End Select
End Function

Sub PrintRefresh
   SetPrintPreviewProperties   : ResizeControls
   CreateHiddenGraphicControl  : CreatePrintContent
   PrintToHiddenGraphic        : PrintToVisibleGraphic
End Sub

Sub ResizeControls
   Local w,h,i,j As Long, sFactor As Single
   Dialog Send hPPDialog, %WM_SetRedraw, 0,0    'turn off draw to prevent flickering

   'resize label (line) and ViewPort dialog
   Dialog Get Client hPPDialog To w,h  :  h = h - 60
   Control Set Size hPPDialog, %IDC_PrintLineLabel, w,1

   'resize hPPViewPort physical size to match hPPDialog
   Dialog Set Size hPPViewPort, w,h           'physical size of hPPViewPort

   'get scroll size of hPPViewPort/ size of the visible graphic (both will be the same)
   Select Case PPZoom
      Case 1
         sFactor = Max(PPPaperX*PPScreenPPIx/w, PPPaperY*PPScreenPPIy/h)
         PPSmallImageX = (PPPaperX * PPScreenPPIx) / sFactor * 0.9
         PPSmallImageY = (PPPaperY * PPScreenPPIx) / sFactor * 0.9
         PPScrollSizeX = w  :  PPScrollSizeY = h
      Case 2
         PPSmallImageX = w - 60
         PPSmallImageY = PPSmallImageX * PPPaperY / PPPaperX
         PPScrollSizeX = w
         PPScrollSizeY = PPSmallImageY + 60  'w * PPPaperY / PPPaperX   'PPSmallImageY + 60
      Case Else
         PPSmallImageX = PPPaperX * PPScreenPPIx * Choose(PPZoom, 1, 1, 0.25, 0.5, 0.75, 1.0, 2.0, 4.0)
         PPSmallImageY = PPPaperY * PPScreenPPIy * Choose(PPZoom, 1, 1, 0.25, 0.5, 0.75, 1.0, 2.0, 4.0)
         PPScrollSizeX = PPSmallImageX + 60
         PPScrollSizeY = PPSmallImageY + 60
         If PPScrollSizeX < w Then PPScrollSizeX = w
         If PPScrollSizeY < h Then PPScrollSizeY = h
   End Select
   PPwMax = PPScrollSizeX : PPhMax = PPScrollSizeY
   ScrollBarInitialize    'set scroll area of hPPViewPort to scaled size of image

   'kill/recreate visible graphic - set to size of scrollable area
   Control Kill hPPViewPort, %IDC_PrintGraphicVisible                                       'kill visible graphic
   Control Add Graphic, hPPViewPort, %IDC_PrintGraphicVisible, "", 0,0,PPScrollSizeX, PPScrollSizeY
   Graphic Attach hPPViewPort, %IDC_PrintGraphicVisible
   Graphic Color %Black, %rgb_LightGray : Graphic Clear

End Sub

Sub SetPrintPreviewProperties
    Local tmi As TextMetric, hDC As Dword
    'PPPrinterPPIx, PPPrinterPPIy
    If Len(XPrint$) = 0 Then XPrint Attach Default    'a printer is needed. use the default if one not selected
    XPrint Get PPI To PPPrinterPPIx,PPPrinterPPIy

    'PPScreenPPIx, PPScreenPPIy
    Graphic Get PPI To PPScreenPPIx,PPScreenPPIy

    'PPPaperX, PPPaperY
    If PPOrientation Then
       PPPaperX = 8.5 : PPPaperY = 11.0   'vertical / portrait
    Else
       PPPaperX = 11 : PPPaperY = 8.5   'horizontal / landscape
    End If

    'PPDeadZone
     XPrint Get Margin To PPDeadZoneLeft, PPDeadZoneTop, PPDeadZoneRight, PPDeadZoneBottom
     PPDeadZoneLeft   = PPDeadZoneLeft   / PPPrinterPPIx
     PPDeadZoneTop    = PPDeadZoneTop    / PPPrinterPPIy
     PPDeadZoneRight  = PPDeadZoneRight  / PPPrinterPPIx
     PPDeadZoneBottom = PPDeadZoneBottom / PPPrinterPPIy

    'PPFooter/PPHeader
     Control Get Check hPPDialog, %IDC_PrintHeader To PPShowHeader
     If PPShowHeader Then PPHeader = 1.1  Else PPHeader = 0  'depends on custom code that prints the header
     Control Get Check hPPDialog, %IDC_PrintFooter To PPShowFooter
     If PPShowFooter Then PPFooter = 1.1  Else PPFooter = 0  'depends on custom code that prints the footer

    'PPMaxWidth
    PPMaxWidth = PPPaperX - PPDeadZoneLeft - PPDeadZoneRight - PPMarginLeft - PPMarginRight

    'PPLinesPerPage
    Graphic Font PPFontName, PPFontPoints, PPFontStyle
    Graphic Clear
    Graphic Get DC To hDC
    GetTextMetrics hDC, tmi
    PPLinesPerPage = (PPPaperY - PPDeadZoneTop - PPDeadZoneBottom - PPHeader - PPFooter - PPMarginTop - PPMarginBottom) * PPScreenPPIy / (tmi.tmExternalLeading + tmi.tmHeight)
End Sub

Sub CreateHiddenGraphicControl
    Control Kill hPPDialog, %IDC_PrintGraphicHidden
    Control Add Graphic, hPPDialog, %IDC_PrintGraphicHidden, "", 500,0,PPPaperX*PPScreenPPIx,PPPaperY*PPScreenPPIy, %WS_Border
    Control Show State hPPDialog, %IDC_PrintGraphicHidden, %SW_Hide
End Sub

Sub CreatePrintContent
   'this routine would be custom for every application
   Local w,h As Long
   Local temp As String

   Graphic Attach hPPDialog, %IDC_PrintGraphicHidden
   Graphic Font PPFontName, PPFontPoints, PPFontStyle
   Graphic Clear

   'put text into array for printing
   Control Get Text hDlg, %IDC_Right To temp
   Control Get Size hPPDialog, %IDC_PrintGraphicHidden To w,h
   temp = Wordwrap(temp, %True)

   ReDim PPPrintArray(ParseCount(temp, $CrLf)-1)
   Parse temp, PPPrintArray(), $CrLf
   PPMaxPages = (UBound(PPPrintArray)\PPLinesPerPage)
   If UBound(PPPrintArray) Mod PPLinesPerPage Then PPMaxPages = PPMaxPages + 1
End Sub

Function WordWrap (temp As String, Flag As Long) As String
   'this routine would be custom for every application
   Local i As Long
   'wordwrap each line individually
   If Flag Then
      'get array of lines of text ($crlf is line separator)
      ReDim PPPrintArray(ParseCount(temp, $CrLf)-1) As String
      Parse temp, PPPrintArray(), $CrLf
      For i = 0 To UBound(PPPrintArray)
         PPPrintArray(i) = SingleLineWordWrap (PPPrintArray(i))
      Next i
      Function = Join$(PPPrintArray(), $CrLf)
   Else
      Replace $CrLf With " " In Temp
      Function = SingleLineWordWrap (temp)
   End If
End Function

Function SingleLineWordWrap(temp As String) As String     'WL=WordList()  mw=MaxWidth (pixel)
   Local i As Long, CL, Rtn As String, w,h As Single
   Dim WL(ParseCount(temp," ")-1) As String
   Parse temp, WL(), " "
   For i = 0 To UBound(WL)
      Graphic Text Size (CL + " " + WL(i)) To w,h        'returns pixels
      w = w / PPScreenPPIx                              'convert to inches
      If w >= PPMaxWidth Or i=UBound(WL) Then
         Rtn = Rtn+IIf$(Len(Rtn),$CrLf,"")+ CL + IIf$(i=UBound(WL), IIf$(w<PPMaxWidth," ",$CrLf)+WL(i),"")
         CL = WL(i)
      Else
         CL = CL + IIf$(i=0,""," ") + WL(i)
      End If
    Next i
    Function = Rtn
End Function

Sub PrintToHiddenGraphic
   'confirm current page exists
   If PPCurrentPage > PPMaxPages Then PPCurrentPage = 1

   'display page number being printed
   Control Set Text hPPDialog, %IDC_PrintPageLabel, Str$(PPCurrentPage)

   'select the hidden graphic control
   Graphic Attach hPPDialog, %IDC_PrintGraphicHidden
   Graphic Font PPFontName, PPFontPoints, PPFontStyle
   Graphic Color %Black, %White
   Graphic Clear

   If PPShowHeader Then PrintHeader          'print header
   PrintText                                 'print text
   If PPShowFooter Then PrintFooter          'print footer
   If PPShowMargins Then PrintMarginOutline  'print outline
End Sub

Sub PrintText
   'print only the lines for the specified page
   Local FirstLine, LastLine, i, j  As Long
   Graphic Set Pos (0,PPScreenPPIx * (PPDeadZoneTop + PPMarginTop + PPHeader))
   FirstLine = (PPCurrentPage-1)*PPLinesPerPage     'zero based array
   LastLine = PPCurrentPage * PPLinesPerPage - 1    'zero based array
   If LastLine > UBound(PPPrintArray) Then LastLine = UBound(PPPrintArray)
   j = PPScreenPPIx*(PPDeadZoneLeft + PPMarginLeft)
   For i = FirstLine To LastLine
      Graphic Set Pos Step (j,0)
      Graphic Print PPPrintArray(i)
   Next i
End Sub

Sub PrintMarginOutline
   Local x,y As Long
   x = PPPaperX * PPScreenPPIx
   y = (PPDeadZoneTop + PPHeader + PPMarginTop)* PPScreenPPIy
   Graphic Style 4
   Graphic Line (0,y)-(x,y)     'top margin left-right line
   y = (PPPaperY - PPDeadZoneBottom - PPFooter - PPMarginBottom)* PPScreenPPIx
   Graphic Line (0,y)-(x,y)     'bottom margin, left-right line
   y = (PPDeadZoneTop + PPHeader)* PPScreenPPIy
   Graphic Line (0,y)-(x,y)     'header, left-right line
   y = (PPPaperY - PPDeadZoneBottom - PPFooter)* PPScreenPPIx
   Graphic Line (0,y)-(x,y)     'footer, left-right line
   y = (PPPaperY - PPDeadZoneBottom)* PPScreenPPIx
   Graphic Line (0,y)-(x,y)     'bottom deadzone, left-right line
   y = (PPDeadZoneTop)* PPScreenPPIy
   Graphic Line (0,y)-(x,y)     'top deadzone, left-right line

   x = (PPDeadZoneLeft + PPMarginLeft) * PPScreenPPIx
   y = PPPaperY * PPScreenPPIy
   Graphic Line (x,0)-(x,y)      'left margin, top-bottom line
   x = (PPPaperX - PPDeadZoneRight - PPMarginRight) * PPScreenPPIx
   Graphic Line (x,0)-(x,y)      'right margin, top-bottom line
   x = (PPPaperX - PPDeadZoneRight) * PPScreenPPIx
   Graphic Line (x,0)-(x,y)      'right deadzone, top-bottom line
   x = (PPDeadZoneLeft) * PPScreenPPIx
   Graphic Line (x,0)-(x,y)      'left deadzone, top-bottom line
End Sub

Sub PrintHeader
   'print header, if desired. can be more complicated than this, hence the SUB
   'must be outside the PPDeadZoneY area at bottom of page
   Local w,h,i,j As Long
   Graphic Attach hPPDialog, %IDC_PrintGraphicHidden
   Graphic Font PPFontName, PPFontPoints, PPFontStyle

   Control Get Size hPPDialog, %IDC_PrintGraphicHidden To w,h
   Graphic Render "cowgirl", ((w-100)/2,PPDeadZoneTop*PPScreenPPIy)-((w-100)/2+99,PPDeadZoneTop*PPScreenPPIy+99)   'cowgirl is 100x100

   Graphic Text Size "Page" + Str$(PPCurrentPage) + " of " + Str$(PPMaxPages) To i,j
   Graphic Set Pos (w-(PPDeadZoneRight+PPMarginRight)*PPScreenPPIx -i-5,PPDeadZoneTop*PPScreenPPIy+5)
   Graphic Print "Page" + Str$(PPCurrentPage) + " of " + Str$(PPMaxPages)
End Sub

Sub PrintFooter
   'print footer, if desired. can be more complicated than this, hence the SUB
   'must be outside the PPDeadZoneY area at top of page
   Local w,h,i,j As Long
   Graphic Attach hPPDialog, %IDC_PrintGraphicHidden
   Graphic Font PPFontName, PPFontPoints, PPFontStyle
   Control Get Size hPPDialog, %IDC_PrintGraphicHidden To w,h
   Graphic Render "cowgirl", ((w-100)/2,h-(PPDeadZoneBottom+PPFooter)*PPScreenPPIy)-((w-100)/2+99,h-(PPDeadZoneBottom+PPFooter)*PPScreenPPIy+99)   'cowgirl is 100x100

   Graphic Set Pos ((PPDeadZoneLeft+PPMarginLeft)*PPScreenPPIx,h-PPDeadZoneBottom*PPScreenPPIy-30)
   Graphic Print CurrentFileName
   Graphic Text Size Date$ + " " + Time$ To i,j
   Graphic Set Pos (w-(PPDeadZoneRight+PPMarginRight)*PPScreenPPIx - i,h-PPDeadZoneBottom*PPScreenPPIy-30)
   Graphic Print Date$ + " " + Time$
End Sub

Sub PrintToVisibleGraphic
    Local whidden,hhidden,w,h As Long
    Local x,y,sFactor,wNew,hNew As Single

    Dialog Send hPPDialog, %WM_SetRedraw, 0,0    'turn off draw to prevent flickering
    Graphic Attach hPPViewPort, %IDC_PrintGraphicVisible
    Graphic Color %Black, %rgb_LightGray : Graphic Clear

    'get the size/location to which the image will be sized
    Select Case PPZoom
       Case 1  'display whole page sized to fit within the dialog
          ShowScrollBar hPPViewPort, %SB_Both, 0       'both not visible
          Control Get Client hPPViewPort, %IDC_PrintGraphicVisible To w,h
          wNew = PPSmallImageX : hNew = PPSmallImageY
          x = (w-wNew)/2       : y = (h-hNew)/2
       Case 2  'display page size to fit width of dialog
          ShowScrollBar hPPViewPort, %SB_Vert, 1       'vertical visible
          wNew = PPSmallImageX : hNew = PPSmallImageY
          x = 20               : y = 20
       Case Else    'display page at UL postion of 20,20  '3-.25 4-.50 5-.75 6-1.0 7-2.0 8-4.0
          ShowScrollBar hPPViewPort, %SB_Both, 1       'both visible
          wNew = PPSmallImageX : hNew = PPSmallImageY
          x = (PPScrollSizeX - PPSmallImageX) / 2
          y = (PPScrollSizeY - PPSmallImageY) / 2
          If (2*x + wNew) < w Then x = (w-wNew)/2
          If (2*y + hNew) < h Then y = (h-hNew)/2
   End Select

   'draw shadow boxes
   Graphic Box (x+10,y+10)-(x+wNew+10,y+hNew+10), 0, %rgb_DimGray, %rgb_DimGray, 0
   Graphic Box (x-1,y-1)-(x+wNew,y+hNew), 0, %Black, %White, 0

   'draw content directly from hidden graphic control
   Control Get Size hPPDialog, %IDC_PrintGraphicHidden To whidden,hhidden
   Graphic Stretch hPPDialog, %IDC_PrintGraphicHidden, (0,0)-(whidden-1,hhidden-1) To (x,y)-(x+wNew-1,y+hNew-1)

   'put the page number on the dialog
   Dialog Set Text hPPDialog, "Print Preview" + Space$(10) + Str$(PPcurrentPage) + " of " + Str$(PPMaxPages) + " Page(s)"

   Dialog Send hPPDialog, %WM_SetRedraw, 1,0
   Dialog ReDraw hPPDialog
   Graphic ReDraw
End Sub


Sub SendToPrinter(Flag As Long)
   '0=all  1=current 2=range
   Local x,y,w, h, MinPage, MaxPage, oldShowMargins As Long
   Local temp As String
   Local RatioX, RatioY As Single

   XPrint Set Font hPPFont
   PPShowMargins = 0

   Control Get Size hPPDialog, %IDC_PrintGraphicHidden To w,h
   x = PPDeadZoneLeft * PPScreenPPIx
   y = PPDeadZoneTop * PPScreenPPIy
   w = w - (PPDeadZoneLeft + PPDeadZoneRight) * PPScreenPPIx
   h = h - (PPDeadZoneTop + PPDeadZoneBottom) * PPScreenPPIy
   Graphic Attach hPPDialog, %IDC_PrintGraphicHidden

   If Len(XPrint$) = 0 Then XPrint Attach Default
   If PPOrientation Then XPrint Set Orientation 1 Else XPrint Set Orientation 2

   RatioX = PPPrinterPPIx / PPScreenPPIx
   RatioY = PPPrinterPPIy / PPScreenPPIy


   Select Case Flag
      Case 0   'all pages
         For PPCurrentPage = 1 To PPMaxPages
            PrintToHiddenGraphic
            XPrint Stretch hPPDialog, %IDC_PrintGraphicHidden, (x,y)-(w-1,h-1) To _
               (RatioX*x,RatioY*y)-(RatioX*w - 1,RatioY*h - 1)
            XPrint FormFeed
         Next PPCurrentPage
      Case 1   'current page only
         PrintToHiddenGraphic
            XPrint Stretch hPPDialog, %IDC_PrintGraphicHidden, (x,y)-(w-1,h-1) To _
               (RatioX*x,RatioY*y)-(RatioX*w - 1,RatioY*h - 1)
         XPrint FormFeed
      Case 2   'range
         Control Get Text hPPDialog, %IDC_PrintMinPage To temp : MinPage = Val(temp)
         Control Get Text hPPDialog, %IDC_PrintMaxPage To temp : MaxPage = Val(temp)
         If MinPage < 1 Then MinPage = 1
         If MinPage > PPMaxPages Then MinPage = PPMaxPages
         If MaxPage < MinPage Then MaxPage = MinPage
         If MaxPage > PPMaxPages Then MaxPage = PPMaxPages
         For PPCurrentPage = MinPage To MaxPage
            PrintToHiddenGraphic
            XPrint Stretch hPPDialog, %IDC_PrintGraphicHidden, (x,y)-(w-1,h-1) To _
               (RatioX*x,RatioY*y)-(RatioX*w - 1,RatioY*h - 1)
            XPrint FormFeed
         Next PPCurrentPage
   End Select
   XPrint Close   'print paper
End Sub

Sub PrintProperties
   'popup MsgBox with current Print Preview parameters
   Local temp, fmt As String
   fmt = "0.00"
   temp = "PPPaperX " + Str$(PPPaperX)
   temp = temp + $CrLf + "PPPaperY " + Format$(PPPaperY,fmt$)
   temp = temp + $CrLf
   temp = temp + $CrLf + "PPMarginLeft " + Format$(PPMarginLeft)
   temp = temp + $CrLf + "PPMarginRight " + Format$(PPMarginRight)
   temp = temp + $CrLf + "PPMarginTop " + Format$(PPMarginTop)
   temp = temp + $CrLf + "PPMarginBottom " + Format$(PPMarginBottom)
   temp = temp + $CrLf
   temp = temp + $CrLf + "PPDeadZoneLeft " + Format$(PPDeadZoneLeft,fmt$)
   temp = temp + $CrLf + "PPDeadZoneTop " + Format$(PPDeadZoneTop,fmt$)
   temp = temp + $CrLf + "PPDeadZoneRight " + Format$(PPDeadZoneRight,fmt$)
   temp = temp + $CrLf + "PPDeadZoneBottom " + Format$(PPDeadZoneBottom,fmt$)
   temp = temp + $CrLf
   temp = temp + $CrLf + "PPFooter " + Format$(PPFooter,fmt$)
   temp = temp + $CrLf + "PPHeader " + Format$(PPHeader,fmt$)
   temp = temp + $CrLf
   temp = temp + $CrLf + "PPScreenPPIx " + Str$(PPScreenPPIx)
   temp = temp + $CrLf + "PPScreenPPIy " + Str$(PPScreenPPIy)
   temp = temp + $CrLf + "PPPrinterPPIx " + Str$(PPPrinterPPIx)
   temp = temp + $CrLf + "PPPrinterPPIy " + Str$(PPPrinterPPIy)
   temp = temp + $CrLf
   temp = temp + $CrLf + "PPMaxPages " + Str$(PPMaxPages)
   temp = temp + $CrLf + "PPCurrentPage " + Str$(PPCurrentPage)
   temp = temp + $CrLf + "PPOrientation " + Str$(PPOrientation)
   temp = temp + $CrLf + "PPLinesPerPage " + Str$(PPLinesPerPage)
   temp = temp + $CrLf + "PPMaxWidth " + Format$(PPMaxWidth,fmt$)
   temp = temp + $CrLf
   temp = temp + $CrLf + "PPSmallImageX" + Str$(PPSmallImageX)
   temp = temp + $CrLf + "PPSmallImageY" + Str$(PPSmallImageY)
   temp = temp + $CrLf + "PPScrollSizeX" + Str$(PPScrollSizeX)
   temp = temp + $CrLf + "PPScrollSizeY" + Str$(PPScrollSizeY)
   MsgBox temp, %MB_Ok, "Print Preview Properties"
End Sub

Sub PrintPageSetup
   Local Style As Long
   Dialog New Pixels, hPPDialog, "Page Setup",100,100,300,165, %WS_OverlappedWindow To hPPPageSetupDlg
   Dialog Set Icon hDlg, "props"
   Style = %WS_Child Or %WS_Visible Or %ES_MultiLine Or %WS_VScroll _
             Or %ES_AutoVScroll Or %ES_WantReturn Or %WS_TabStop Or %WS_Border

   Control Add Label, hPPPageSetupDlg, 200, "Orientation",   10, 10, 60, 20
   Control Add Label, hPPPageSetupDlg, 201, "Margins",   175, 10, 60, 20

   Control Add TextBox, hPPPageSetupDlg, 202, Str$(PPMarginTop),    180, 48, 40, 20, %ES_Center Or %WS_TabStop Or %WS_Border, %WS_Ex_ClientEdge
   Control Add TextBox, hPPPageSetupDlg, 203, Str$(PPMarginLeft),   145, 68, 40, 20, %ES_Center Or %WS_TabStop Or %WS_Border, %WS_Ex_ClientEdge
   Control Add TextBox, hPPPageSetupDlg, 204, Str$(PPMarginRight),  215, 68, 40, 20, %ES_Center Or %WS_TabStop Or %WS_Border, %WS_Ex_ClientEdge
   Control Add TextBox, hPPPageSetupDlg, 205, Str$(PPMarginBottom), 180, 90, 40, 20, %ES_Center Or %WS_TabStop Or %WS_Border, %WS_Ex_ClientEdge

   Control Add Label, hPPPageSetupDlg, 206, "Top",    188,  30, 40, 20
   Control Add Label, hPPPageSetupDlg, 207, "Left",   120,  70, 25, 20
   Control Add Label, hPPPageSetupDlg, 208, "Right",  260,  70, 40, 20
   Control Add Label, hPPPageSetupDlg, 209, "Bottom", 183,  110, 40, 20

   Control Add Button, hPPPageSetupDlg, 210,"Ok", 90,135,60,20
   Control Add Button, hPPPageSetupDlg, 211,"Apply", 160,135,60,20
   Control Add Button, hPPPageSetupDlg, 212,"Cancel", 230,135,60,20

   Control Add Option, hPPPageSetupDlg, 213, "Portrait",  15, 30, 60,20
   Control Add Option, hPPPageSetupDlg, 214, "Landscape", 15, 50, 75, 20

   Dialog Show Modal hPPPageSetupDlg Call SetupDlgProc
End Sub

CallBack Function SetupDlgProc() As Long
   Select Case Cb.Msg
      Case %WM_InitDialog
         Control Set Text hPPPageSetupDlg, 202, Trim$(Str$(PPMarginTop))
         Control Set Text hPPPageSetupDlg, 203, Trim$(Str$(PPMarginLeft))
         Control Set Text hPPPageSetupDlg, 204, Trim$(Str$(PPMarginRight))
         Control Set Text hPPPageSetupDlg, 205, Trim$(Str$(PPMarginBottom))
         If PPOrientation Then Control Set Check hPPPageSetupDlg, 213, 1
         If IsFalse(PPOrientation) Then Control Set Check hPPPageSetupDlg, 214, 1
      Case %WM_Command
         Select Case Cb.Ctl
            Case 210 : PrintSaveSetup : PrintRefresh : Dialog End hPPPageSetupDlg
            Case 211 : PrintSaveSetup : PrintRefresh
            Case 212 : Dialog End hPPPageSetupDlg
         End Select
      Case %WM_Destroy

   End Select
End Function

Sub PrintSaveSetup
   Local temp As String
   Control Get Check hPPPageSetupDlg, 213 To PPOrientation
   Control Get Text hPPPageSetupDlg, 202 To temp : PPMarginTop = Val(temp)
   Control Get Text hPPPageSetupDlg, 203 To temp : PPMarginLeft = Val(temp)
   Control Get Text hPPPageSetupDlg, 204 To temp : PPMarginRight = Val(temp)
   Control Get Text hPPPageSetupDlg, 205 To temp : PPMarginBottom = Val(temp)
End Sub

Sub CreateToolTipControl (hWnd As Dword)
   hPPToolTip = CreateWindowEx(ByVal 0, "tooltips_class32", "", %TTS_ALWAYSTIP,  _
           0, 0, 0, 0, ByVal hWnd, ByVal 0, GetModuleHandle(ByVal %NULL), ByVal 0)
'   Dialog Send hPPToolTip, %TTM_SETMAXTIPWIDTH, 0, 200                                '200 seems appropriate
'   Dialog Send hPPToolTip, %TTM_SETDELAYTIME, %TTDT_AUTOPOP, 3000                     '3000 = 3 seconds
End Sub

Sub CreateToolTips
   SetToolTipText %IDC_PrinterSelect,    "Select Printer"
   SetToolTipText %IDC_PrintPageSetup,   "Page Setup"
   SetToolTipText %IDC_PrintLeft,        "Display Previous Page"
   SetToolTipText %IDC_PrintRight,       "Display Next Page"
   SetToolTipText %IDC_PrintAll,         "Print All Pages"
   SetToolTipText %IDC_PrintPage,        "Print Current Page"
   SetToolTipText %IDC_PrintRange,       "Print Page Range"
   SetToolTipText %IDC_PrintOrientation, "Change Orientation"
   SetToolTipText %IDC_PrintShowMargins,  "Show Margins"
   SetToolTipText %IDC_PrintClose,       "Close Without Applying"
End Sub

Sub SetToolTipText(Id As Long, ByVal txt As String)
   Local hLocalDlg As Dword
   Local ti As TOOLINFO
   Local aToolTipText As Asciiz * 256

   aToolTipText = txt
   hLocalDlg    = GetParent(hPPToolTip)
   ti.cbSize    = Len(ti)
   ti.uFlags    = %TTF_SUBCLASS Or %TTF_IDISHWND
   ti.hWnd      = hLocalDlg
   ti.uId       = GetDlgItem(hLocalDlg, Id)
   ti.lpszText  = VarPtr(aToolTipText)
   SendMessage hPPToolTip, %TTM_ADDTOOL, 0, VarPtr(ti)
End Sub

Sub ScrollBarInitialize
   Local si As ScrollInfo, wClient,hClient As Long
   Dialog Get Client hPPViewPort To wClient, hClient                             'w/o scrollbars (called from WM_InitDialog)
   wClient -= GetSystemMetrics(%SM_CXVSCROLL)                             'less vertical scrollbar
   hClient -= GetSystemMetrics(%SM_CXHSCROLL)                             'less horizontal scrollbar
   si.cbSize=Len(si) : si.fMask=%SIF_All                                  'preset values before using SetScrollInfo
   si.nMax=PPhMax : si.nPage=hClient : SetScrollInfo hPPViewPort, %SB_Vert, si, 1  'set Vert scrollbar properties
   si.nMax=PPwMax : si.nPage=wClient : SetScrollInfo hPPViewPort, %SB_Horz, si, 1  'set Horz scrollbar properties
End Sub

Sub ScrollBarRespond(HorzVert As Long, wParam As Long)
   Local si As ScrollInfo, wClient, hClient, oldPos As Long
   si.cbSize=SizeOf(si) : si.fMask=%SIF_All
   GetScrollInfo hPPViewPort, HorzVert, si
   oldPos=si.nPos
   Select Case Lo(Word, wParam)
      Case %SB_LineLeft, %SB_LineUp    :  si.nPos -= IIf(HorzVert,PPhs,PPvs)
      Case %SB_PageLeft, %SB_PageUp    :  si.nPos -= si.nPage
      Case %SB_LineRight, %SB_LineDown :  si.nPos += IIf(HorzVert,PPhs,PPvs)
      Case %SB_PageRight, %SB_PageDown :  si.nPos += si.nPage
      Case %SB_ThumbTrack              :  si.nPos=Hi(Word, wParam)
      Case Else                        :  Exit Sub
   End Select
   si.nPos=Max&(si.nMin, Min&(si.nPos, si.nMax-si.nPage))
   SetScrollInfo hPPViewPort,HorzVert,si,1
   If HorzVert = %SB_Horz Then ScrollWindow hPPViewPort, oldPos-si.nPos,0 , ByVal %NULL, ByVal %NULL
   If HorzVert = %SB_Vert Then ScrollWindow hPPViewPort, 0, oldPos-si.nPos, ByVal %NULL, ByVal %NULL
End Sub
